;ntddk.inc
;=========

Macro KIRQL:u:EndMacro
Macro PKIRQL:unicode:EndMacro
Macro KAFFINITY:l:EndMacro
Macro PKAFFINITY:long:EndMacro

Structure LIST_ENTRY Align #PB_Structure_AlignC
  *Flink.LIST_ENTRY
  *Blink.LIST_ENTRY
EndStructure

Structure SINGLE_LIST_ENTRY Align #PB_Structure_AlignC
  *Next
EndStructure

Structure ANSI_STRING Align #PB_Structure_AlignC
  Length.w
  MaximumLength.w
  *Buffer
EndStructure

Structure UNICODE_STRING Align #PB_Structure_AlignC
  Length.w
  MaximumLength.w
  *Buffer
EndStructure

CompilerIf Defined(LARGE_INTEGER, #PB_Structure)=0
  
  Structure LARGE_INTEGER__
    LowPart.l
    HighPart.l
  EndStructure
  
  Structure LARGE_INTEGER Align #PB_Structure_AlignC
    StructureUnion
      Part.LARGE_INTEGER__
      QuadPart.q
    EndStructureUnion
  EndStructure
CompilerEndIf

#IRP_MJ_CREATE                   = $00
#IRP_MJ_CREATE_NAMED_PIPE        = $01
#IRP_MJ_CLOSE                    = $02
#IRP_MJ_READ                     = $03
#IRP_MJ_WRITE                    = $04
#IRP_MJ_QUERY_INFORMATION        = $05
#IRP_MJ_SET_INFORMATION          = $06
#IRP_MJ_QUERY_EA                 = $07
#IRP_MJ_SET_EA                   = $08
#IRP_MJ_FLUSH_BUFFERS            = $09
#IRP_MJ_QUERY_VOLUME_INFORMATION = $0a
#IRP_MJ_SET_VOLUME_INFORMATION   = $0b
#IRP_MJ_DIRECTORY_CONTROL        = $0c
#IRP_MJ_FILE_SYSTEM_CONTROL      = $0d
#IRP_MJ_DEVICE_CONTROL           = $0e
#IRP_MJ_INTERNAL_DEVICE_CONTROL  = $0f
#IRP_MJ_SHUTDOWN                 = $10
#IRP_MJ_LOCK_CONTROL             = $11
#IRP_MJ_CLEANUP                  = $12
#IRP_MJ_CREATE_MAILSLOT          = $13
#IRP_MJ_QUERY_SECURITY           = $14
#IRP_MJ_SET_SECURITY             = $15
#IRP_MJ_POWER                    = $16
#IRP_MJ_SYSTEM_CONTROL           = $17
#IRP_MJ_DEVICE_CHANGE            = $18
#IRP_MJ_QUERY_QUOTA              = $19
#IRP_MJ_SET_QUOTA                = $1a
#IRP_MJ_PNP                      = $1b
#IRP_MJ_PNP_POWER                = #IRP_MJ_PNP      ; Obsolete....
#IRP_MJ_MAXIMUM_FUNCTION         = $1b
#IRP_MJ_SCSI                     = #IRP_MJ_INTERNAL_DEVICE_CONTROL


#PAGE_SIZE=$1000

;BOOLEAN
#False=0
#Null=0
#True=1

;PROCESSOR MODE
#KernelMode=0
#UserMode=1
#MaximumMode=2

;MM_PAGE_PRIORITY
#LowPagePriority=0
#NormalPagePriority=16
#HighPagePriority=32

;#MmLockPagableCodeSection=#MmLockPagableDataSection

;MEMORY_CACHING_TYPE
#MmNonCached=0;FALSE
#MmCached=1;TRUE
#MmWriteCombined=2
#MmHardwareCoherentCached=3
#MmNonCachedUnordered=4;IA64
#MmUSWCCached=5
#MmMaximumCacheType=6

;INTERRUPT REQUEST LEVEL DEFINITIONS
#PASSIVE_LEVEL=0;Passive release level
#LOW_LEVEL=0;Lowest interrupt level
#APC_LEVEL=1;APC interrupt level
#DISPATCH_LEVEL=2;Dispatcher level
#CMCI_LEVEL=5;CMCI handler level

#PROFILE_LEVEL=27;timer used for profiling.
#CLOCK1_LEVEL=28;Interval clock 1 level - Not used on x86
#CLOCK2_LEVEL=28;Interval clock 2 level
#IPI_LEVEL=29;Interprocessor interrupt level
#POWER_LEVEL=30;Power failure level
#HIGH_LEVEL=31;Highest interrupt level

;Define the I/O bus interface types (les 4 premiers - wdm.h/INTERFACE_TYPE)
#InterfaceTypeUndefined=-1
#Internal=0
#Isa=1
#Eisa=2

;
;Define Device Object (DO) flags
;
#DO_VERIFY_VOLUME=$00000002
#DO_BUFFERED_IO=$00000004
#DO_EXCLUSIVE=$00000008
#DO_DIRECT_IO=$00000010
#DO_MAP_IO_BUFFER=$00000020
#DO_DEVICE_INITIALIZING=$00000080
#DO_SHUTDOWN_REGISTERED=$00000800
#DO_BUS_ENUMERATED_DEVICE=$00001000
#DO_POWER_PAGABLE=$00002000
#DO_POWER_INRUSH=$00004000

;
; Valid values for the Attributes field
;

#OBJ_INHERIT=$00000002
#OBJ_PERMANENT=$00000010
#OBJ_EXCLUSIVE=$00000020
#OBJ_CASE_INSENSITIVE=$00000040
#OBJ_OPENIF=$00000080
#OBJ_OPENLINK=$00000100
#OBJ_KERNEL_HANDLE=$00000200
#OBJ_FORCE_ACCESS_CHECK=$00000400
#OBJ_VALID_ATTRIBUTES=$000007F2


Structure OBJECT_ATTRIBUTES Align #PB_Structure_AlignC
  Length.l
  RootDirectory.i
  ObjectName.i
  Attributes.l
  SecurityDescriptor.i
  SecurityQualityOfService.i
EndStructure

Structure SYSTEM_SERVICE_TABLE_Array
  *ar[0]
EndStructure

Structure SYSTEM_SERVICE_TABLE Align #PB_Structure_AlignC
  *ServiceTable.SYSTEM_SERVICE_TABLE_Array
  *CounterTable
  ServiceLimit.l
  *ArgumentTable.SYSTEM_SERVICE_TABLE_Array
EndStructure

Structure SERVICE_DESCRIPTOR_TABLE Align #PB_Structure_AlignC
  ntoskrnl.SYSTEM_SERVICE_TABLE
  win32k.SYSTEM_SERVICE_TABLE
  unused1.SYSTEM_SERVICE_TABLE
  unused2.SYSTEM_SERVICE_TABLE
EndStructure

Structure CLIENT_ID Align #PB_Structure_AlignC
  UniqueProcess.i
  UniqueThread.i
EndStructure
;
;------------------------------------------------------------------------------
Structure LDR_DATA_TABLE_ENTRY Align #PB_Structure_AlignC

    *Reserved1[2];
    InMemoryOrderLinks.LIST_ENTRY;
    *Reserved2[2];
    *DllBase;
    *EntryPoint;
    *Reserved3;
    FullDllName.UNICODE_STRING
    Reserved4.b[8];
    *Reserved5[3];
    StructureUnion
        CheckSum.l
        *Reserved6
    EndStructureUnion
  ;
EndStructure

;
;------------------------------------------------------------------------------
;
; Event Specific Access Rights.
;

#EVENT_QUERY_STATE=$0001
#EVENT_MODIFY_STATE=$0002; winnt
#EVENT_ALL_ACCESS=(#STANDARD_RIGHTS_REQUIRED | #SYNCHRONIZE | $3); winnt

;
; Semaphore Specific Access Rights.
;

#SEMAPHORE_QUERY_STATE=$0001
#SEMAPHORE_MODIFY_STATE=$0002; winnt
#SEMAPHORE_ALL_ACCESS=(#STANDARD_RIGHTS_REQUIRED | #SYNCHRONIZE | $3); winnt



; --------------------------[ POOL_TYPE ]-----------------------------------------

#NonPagedPool=0
#PagedPool=1
#NonPagedPoolMustSucceed=2
#DontUseThisType=3
#NonPagedPoolCacheAligned=4
#PagedPoolCacheAligned=5
#NonPagedPoolCacheAlignedMustS=6
#MaxPoolType=7

;
; Note these per session types are carefully chosen so that the appropriate
; masking still applies as well as MaxPoolType above.
;

#NonPagedPoolSession=32
#PagedPoolSession=#NonPagedPoolSession + 1
#NonPagedPoolMustSucceedSession=#PagedPoolSession + 1
#DontUseThisTypeSession=#NonPagedPoolMustSucceedSession + 1
#NonPagedPoolCacheAlignedSession=#DontUseThisTypeSession + 1
#PagedPoolCacheAlignedSession=#NonPagedPoolCacheAlignedSession + 1
#NonPagedPoolCacheAlignedMustSSession=#PagedPoolCacheAlignedSession + 1



;
; Kernel Mutex Level Numbers (must be globallly assigned within executive)
; The third token in the name is the sub-component name that defines and
; uses the level number.
;

;
; Used by Vdm for protecting io simulation structures
;

#MUTEX_LEVEL_VDM_IO=$00000001

#MUTEX_LEVEL_EX_PROFILE=$00000040

;
; The LANMAN Redirector uses the file system major function, but defines
; it's own mutex levels. We can do this safely because we know that the
; local filesystem will never call the remote filesystem and vice versa.
;

#MUTEX_LEVEL_RDR_FILESYS_DATABASE=$10100000
#MUTEX_LEVEL_RDR_FILESYS_SECURITY=$10100001

;
; File System levels.
;

#MUTEX_LEVEL_FILESYSTEM_RAW_VCB=$11000006

;
; In the NT STREAMS environment, a mutex is used to serialize open, close
; and Scheduler threads executing in a subsystem-parallelized stack.
;

#MUTEX_LEVEL_STREAMS_SUBSYS=$11001001

;
; Mutex level used by LDT support on x86
;

#MUTEX_LEVEL_PS_LDT=$1F000000



Structure MDL Align #PB_Structure_AlignC
  Next_.i
  Size.w
  MdlFlags.w  
  Process.i
  MappedSystemVa.i
  StartVa.i
  ByteCount.l
  ByteOffset.l
EndStructure

#MDL_MAPPED_TO_SYSTEM_VA=$0001
#MDL_PAGES_LOCKED=$0002
#MDL_SOURCE_IS_NONPAGED_POOL=$0004
#MDL_ALLOCATED_FIXED_SIZE=$0008
#MDL_PARTIAL=$0010
#MDL_PARTIAL_HAS_BEEN_MAPPED=$0020
#MDL_IO_PAGE_READ=$0040
#MDL_WRITE_OPERATION=$0080
#MDL_PARENT_MAPPED_SYSTEM_VA=$0100
#MDL_FREE_EXTRA_PTES=$0200
;#MDL_DESCRIBES_AWE=$0400
#MDL_SYSTEM_VA=$0400; ou $600 ?
#MDL_IO_SPACE=$0800
#MDL_NETWORK_HEADER=$1000
#MDL_MAPPING_CAN_FAIL=$2000
#MDL_ALLOCATED_MUST_SUCCEED=$4000
#MDL_INTERNAL=$8000


#MDL_MAPPING_FLAGS=( #MDL_MAPPED_TO_SYSTEM_VA | #MDL_PAGES_LOCKED | #MDL_SOURCE_IS_NONPAGED_POOL | #MDL_PARTIAL_HAS_BEEN_MAPPED | #MDL_PARENT_MAPPED_SYSTEM_VA | #MDL_SYSTEM_VA | #MDL_IO_SPACE)



;Size of kernel mode stack
;-------------------------
#KERNEL_STACK_SIZE=$3000

;Define size of large kernel mode stack for callbacks
;----------------------------------------------------
#KERNEL_LARGE_STACK_SIZE=$F000

;Define number of pages to initialize in a large kernel stack
;------------------------------------------------------------
#KERNEL_LARGE_STACK_COMMIT=$3000

;Define the size of the stack used for processing an MCA exception
;-----------------------------------------------------------------
#KERNEL_MCA_EXCEPTION_STACK_SIZE=$2000


;
; The following flags control the contents of the CONTEXT structure.
;

#CONTEXT_i386=$00010000; this assumes that i386 and
#CONTEXT_i486=$00010000; i486 have identical context records

#CONTEXT_CONTROL=#CONTEXT_i386 | $00000001; SS:SP, CS:IP, FLAGS, BP
#CONTEXT_INTEGER=#CONTEXT_i386 | $00000002; AX, BX, CX, DX, SI, DI
#CONTEXT_SEGMENTS=#CONTEXT_i386 | $00000004; DS, ES, FS, GS
#CONTEXT_FLOATING_POINT=#CONTEXT_i386 | $00000008; 387 state
#CONTEXT_DEBUG_REGISTERS=#CONTEXT_i386 | $00000010; DB 0-3,6,7
#CONTEXT_EXTENDED_REGISTERS=#CONTEXT_i386 | $00000020; cpu specific extensions

#CONTEXT_FULL=#CONTEXT_CONTROL | #CONTEXT_INTEGER | #CONTEXT_SEGMENTS
#CONTEXT_ALL=#CONTEXT_FULL | #CONTEXT_FLOATING_POINT | #CONTEXT_DEBUG_REGISTERS | #CONTEXT_EXTENDED_REGISTERS

;The following are masks for the predefined standard access types
;----------------------------------------------------------------

#DELETE=$00010000
#READ_CONTROL=$00020000
#WRITE_DAC=$00040000
#WRITE_OWNER=$00080000
#SYNCHRONIZE=$00100000

#STANDARD_RIGHTS_REQUIRED=$000F0000

#STANDARD_RIGHTS_READ=#READ_CONTROL
#STANDARD_RIGHTS_WRITE=#READ_CONTROL
#STANDARD_RIGHTS_EXECUTE=#READ_CONTROL

#STANDARD_RIGHTS_ALL=$001F0000

#SPECIFIC_RIGHTS_ALL=$0000FFFF

;
; AccessSystemAcl access type
;

#ACCESS_SYSTEM_SECURITY=$01000000

;
; MaximumAllowed access type
;

#MAXIMUM_ALLOWED=$02000000

;
; These are the generic rights.
;

#GENERIC_READ=$80000000
#GENERIC_WRITE=$40000000
#GENERIC_EXECUTE=$20000000
#GENERIC_ALL=$10000000

;
; Current security descriptor revision value
;

#SECURITY_DESCRIPTOR_REVISION=1
#SECURITY_DESCRIPTOR_REVISION1=1

;
; Privilege attributes
;

#SE_PRIVILEGE_ENABLED_BY_DEFAULT=$00000001
#SE_PRIVILEGE_ENABLED=$00000002
#SE_PRIVILEGE_USED_FOR_ACCESS=$80000000

;
; Privilege Set Control flags
;

#PRIVILEGE_SET_ALL_NECESSARY=1

;
; Define the various device type values. Note that values used by Microsoft
; Corporation are in the range 0-32767, and 32768-65535 are reserved for use
; by customers.
;

#FILE_DEVICE_BEEP=$00000001
#FILE_DEVICE_CD_ROM=$00000002
#FILE_DEVICE_CD_ROM_FILE_SYSTEM=$00000003
#FILE_DEVICE_CONTROLLER=$00000004
#FILE_DEVICE_DATALINK=$00000005
#FILE_DEVICE_DFS=$00000006
#FILE_DEVICE_DISK=$00000007
#FILE_DEVICE_DISK_FILE_SYSTEM=$00000008
#FILE_DEVICE_FILE_SYSTEM=$00000009
#FILE_DEVICE_INPORT_PORT=$0000000a
#FILE_DEVICE_KEYBOARD=$0000000b
#FILE_DEVICE_MAILSLOT=$0000000c
#FILE_DEVICE_MIDI_IN=$0000000d
#FILE_DEVICE_MIDI_OUT=$0000000e
#FILE_DEVICE_MOUSE=$0000000f
#FILE_DEVICE_MULTI_UNC_PROVIDER=$00000010
#FILE_DEVICE_NAMED_PIPE=$00000011
#FILE_DEVICE_NETWORK=$00000012
#FILE_DEVICE_NETWORK_BROWSER=$00000013
#FILE_DEVICE_NETWORK_FILE_SYSTEM=$00000014
#FILE_DEVICE_NULL=$00000015
#FILE_DEVICE_PARALLEL_PORT=$00000016
#FILE_DEVICE_PHYSICAL_NETCARD=$00000017
#FILE_DEVICE_PRINTER=$00000018
#FILE_DEVICE_SCANNER=$00000019
#FILE_DEVICE_SERIAL_MOUSE_PORT=$0000001a
#FILE_DEVICE_SERIAL_PORT=$0000001b
#FILE_DEVICE_SCREEN=$0000001c
#FILE_DEVICE_SOUND=$0000001d
#FILE_DEVICE_STREAMS=$0000001e
#FILE_DEVICE_TAPE=$0000001f
#FILE_DEVICE_TAPE_FILE_SYSTEM=$00000020
#FILE_DEVICE_TRANSPORT=$00000021
#FILE_DEVICE_UNKNOWN=$00000022
#FILE_DEVICE_VIDEO=$00000023
#FILE_DEVICE_VIRTUAL_DISK=$00000024
#FILE_DEVICE_WAVE_IN=$00000025
#FILE_DEVICE_WAVE_OUT=$00000026
#FILE_DEVICE_8042_PORT=$00000027
#FILE_DEVICE_NETWORK_REDIRECTOR=$00000028
#FILE_DEVICE_BATTERY=$00000029
#FILE_DEVICE_BUS_EXTENDER=$0000002a
#FILE_DEVICE_MODEM=$0000002b
#FILE_DEVICE_VDM=$0000002c
#FILE_DEVICE_MASS_STORAGE=$0000002d
#FILE_DEVICE_SMB=$0000002e
#FILE_DEVICE_KS=$0000002f
#FILE_DEVICE_CHANGER=$00000030
#FILE_DEVICE_SMARTCARD=$00000031
#FILE_DEVICE_ACPI=$00000032
#FILE_DEVICE_DVD=$00000033
#FILE_DEVICE_FULLSCREEN_VIDEO=$00000034
#FILE_DEVICE_DFS_FILE_SYSTEM=$00000035
#FILE_DEVICE_DFS_VOLUME=$00000036
#FILE_DEVICE_SERENUM=$00000037
#FILE_DEVICE_TERMSRV=$00000038
#FILE_DEVICE_KSEC=$00000039
#FILE_DEVICE_FIPS=$0000003A

;
; Define the method codes for how buffers are passed for I/O and FS controls
;

#METHOD_BUFFERED=0
#METHOD_IN_DIRECT=1
#METHOD_OUT_DIRECT=2
#METHOD_NEITHER=3

;
; Define the access check value for any access
;
;
; The FILE_READ_ACCESS and FILE_WRITE_ACCESS constants are also defined in
; ntioapi.h as FILE_READ_DATA and FILE_WRITE_DATA. The values for these
; constants *MUST* always be in sync.
;
;
; FILE_SPECIAL_ACCESS is checked by the NT I/O system the same as FILE_ANY_ACCESS.
; The file systems, however, may add additional access checks for I/O and FS controls
; that use this value.
;


#FILE_ANY_ACCESS=0
#FILE_SPECIAL_ACCESS=#FILE_ANY_ACCESS
#FILE_READ_ACCESS=$0001; file & pipe
#FILE_WRITE_ACCESS=$0002; file & pipe

; begin_winnt

;
; Define access rights to files and directories
;

;
; The FILE_READ_DATA and FILE_WRITE_DATA constants are also defined in
; devioctl.h as FILE_READ_ACCESS and FILE_WRITE_ACCESS. The values for these
; constants *MUST* always be in sync.
; The values are redefined in devioctl.h because they must be available to
; both DOS and NT.
;

#FILE_READ_DATA=$0001; file & pipe
#FILE_LIST_DIRECTORY=$0001; directory

#FILE_WRITE_DATA=$0002; file & pipe
#FILE_ADD_FILE=$0002; directory

#FILE_APPEND_DATA=$0004; file
#FILE_ADD_SUBDIRECTORY=$0004; directory
#FILE_CREATE_PIPE_INSTANCE=$0004; named pipe


#FILE_READ_EA=$0008; file & directory

#FILE_WRITE_EA=$0010; file & directory

#FILE_EXECUTE=$0020; file
#FILE_TRAVERSE=$0020; directory

#FILE_DELETE_CHILD=$0040; directory

#FILE_READ_ATTRIBUTES=$0080; all

#FILE_WRITE_ATTRIBUTES=$0100; all

#FILE_ALL_ACCESS=#STANDARD_RIGHTS_REQUIRED | #SYNCHRONIZE | $1FF

#FILE_GENERIC_READ=#STANDARD_RIGHTS_READ | #FILE_READ_DATA | #FILE_READ_ATTRIBUTES | #FILE_READ_EA | #SYNCHRONIZE


#FILE_GENERIC_WRITE=#STANDARD_RIGHTS_WRITE | #FILE_WRITE_DATA | #FILE_WRITE_ATTRIBUTES | #FILE_WRITE_EA | #FILE_APPEND_DATA | #SYNCHRONIZE


#FILE_GENERIC_EXECUTE=#STANDARD_RIGHTS_EXECUTE | #FILE_READ_ATTRIBUTES | #FILE_EXECUTE | #SYNCHRONIZE

; end_winnt


;
; Define share access rights to files and directories
;

#FILE_SHARE_READ=$00000001; winnt
#FILE_SHARE_WRITE=$00000002; winnt
#FILE_SHARE_DELETE=$00000004; winnt
#FILE_SHARE_VALID_FLAGS=$00000007

;
; Define the file attributes values
;
; Note: $00000008 is reserved for use for the old DOS VOLID (volume ID)
; and is therefore not considered valid in NT.
;
; Note: $00000010 is reserved for use for the old DOS SUBDIRECTORY flag
; and is therefore not considered valid in NT. This flag has
; been disassociated with file attributes since the other flags are
; protected with READ_ and WRITE_ATTRIBUTES access to the file.
;
; Note: Note also that the order of these flags is set to allow both the
; FAT and the Pinball File Systems to directly set the attributes
; flags in attributes words without having to pick each flag out
; individually. The order of these flags should not be changed!
;

#FILE_ATTRIBUTE_READONLY=$00000001; winnt
#FILE_ATTRIBUTE_HIDDEN=$00000002; winnt
#FILE_ATTRIBUTE_SYSTEM=$00000004; winnt
;OLD DOS VOLID=$00000008

#FILE_ATTRIBUTE_DIRECTORY=$00000010; winnt
#FILE_ATTRIBUTE_ARCHIVE=$00000020; winnt
#FILE_ATTRIBUTE_DEVICE=$00000040; winnt
#FILE_ATTRIBUTE_NORMAL=$00000080; winnt

#FILE_ATTRIBUTE_TEMPORARY=$00000100; winnt
#FILE_ATTRIBUTE_SPARSE_FILE=$00000200; winnt
#FILE_ATTRIBUTE_REPARSE_POINT=$00000400; winnt
#FILE_ATTRIBUTE_COMPRESSED=$00000800; winnt

#FILE_ATTRIBUTE_OFFLINE=$00001000; winnt
#FILE_ATTRIBUTE_NOT_CONTENT_INDEXED=$00002000; winnt
#FILE_ATTRIBUTE_ENCRYPTED=$00004000; winnt

#FILE_ATTRIBUTE_VALID_FLAGS=$00007fb7
#FILE_ATTRIBUTE_VALID_SET_FLAGS=$000031a7

;
; Define the create disposition values
;

#FILE_SUPERSEDE=$00000000
#FILE_OPEN=$00000001
#FILE_CREATE=$00000002
#FILE_OPEN_IF=$00000003
#FILE_OVERWRITE=$00000004
#FILE_OVERWRITE_IF=$00000005
#FILE_MAXIMUM_DISPOSITION=$00000005

;
; Define the create/open option flags
;

#FILE_DIRECTORY_FILE=$00000001
#FILE_WRITE_THROUGH=$00000002
#FILE_SEQUENTIAL_ONLY=$00000004
#FILE_NO_INTERMEDIATE_BUFFERING=$00000008

#FILE_SYNCHRONOUS_IO_ALERT=$00000010
#FILE_SYNCHRONOUS_IO_NONALERT=$00000020
#FILE_NON_DIRECTORY_FILE=$00000040
#FILE_CREATE_TREE_CONNECTION=$00000080

#FILE_COMPLETE_IF_OPLOCKED=$00000100
#FILE_NO_EA_KNOWLEDGE=$00000200
#FILE_OPEN_FOR_RECOVERY=$00000400
#FILE_RANDOM_ACCESS=$00000800

#FILE_DELETE_ON_CLOSE=$00001000
#FILE_OPEN_BY_FILE_ID=$00002000
#FILE_OPEN_FOR_BACKUP_INTENT=$00004000
#FILE_NO_COMPRESSION=$00008000

#FILE_RESERVE_OPFILTER=$00100000
#FILE_OPEN_REPARSE_POINT=$00200000
#FILE_OPEN_NO_RECALL=$00400000
#FILE_OPEN_FOR_FREE_SPACE_QUERY=$00800000

#FILE_COPY_STRUCTURED_STORAGE=$00000041
#FILE_STRUCTURED_STORAGE=$00000441

#FILE_VALID_OPTION_FLAGS=$00ffffff
#FILE_VALID_PIPE_OPTION_FLAGS=$00000032
#FILE_VALID_MAILSLOT_OPTION_FLAGS=$00000032
#FILE_VALID_SET_FLAGS=$00000036

;
; Define the I/O status information return values for NtCreateFile/NtOpenFile
;

#FILE_SUPERSEDED=$00000000
#FILE_OPENED=$00000001
#FILE_CREATED=$00000002
#FILE_OVERWRITTEN=$00000003
#FILE_EXISTS=$00000004
#FILE_DOES_NOT_EXIST=$00000005

;
; Define special ByteOffset parameters for read and write operations
;

#FILE_WRITE_TO_END_OF_FILE=$ffffffff
#FILE_USE_FILE_POINTER_POSITION=$fffffffe

;
; Define alignment r=irement values
;

#FILE_BYTE_ALIGNMENT=$00000000
#FILE_WORD_ALIGNMENT=$00000001
#FILE_LONG_ALIGNMENT=$00000003
#FILE_QUAD_ALIGNMENT=$00000007
#FILE_OCTA_ALIGNMENT=$0000000f
#FILE_32_BYTE_ALIGNMENT=$0000001f
#FILE_64_BYTE_ALIGNMENT=$0000003f
#FILE_128_BYTE_ALIGNMENT=$0000007f
#FILE_256_BYTE_ALIGNMENT=$000000ff
#FILE_512_BYTE_ALIGNMENT=$000001ff

;
; Define the maximum length of a filename string
;

#MAXIMUM_FILENAME_LENGTH=256

;
; Define the various device characteristics flags
;

#FILE_REMOVABLE_MEDIA=$00000001
#FILE_READ_ONLY_DEVICE=$00000002
#FILE_FLOPPY_DISKETTE=$00000004
#FILE_WRITE_ONCE_MEDIA=$00000008
#FILE_REMOTE_DEVICE=$00000010
#FILE_DEVICE_IS_MOUNTED=$00000020
#FILE_VIRTUAL_VOLUME=$00000040
#FILE_AUTOGENERATED_DEVICE_NAME=$00000080
#FILE_DEVICE_SECURE_OPEN=$00000100

; end_wdm

;
; The FILE_EXPECT flags will only exist for WinXP. After that they will be
; ignored and an IRP will be sent in their place.
;
#FILE_CHARACTERISTICS_EXPECT_ORDERLY_REMOVAL=$00000200
#FILE_CHARACTERISTICS_EXPECT_SURPRISE_REMOVAL=$00000300
#FILE_CHARACTERISTICS_REMOVAL_POLICY_MASK=$00000300

;
; flags specified here will be propagated up and down a device stack
; after FDO and all filter devices are added, but before the device
; stack is started
;

#FILE_CHARACTERISTICS_PROPAGATED=#FILE_REMOVABLE_MEDIA | #FILE_READ_ONLY_DEVICE | #FILE_FLOPPY_DISKETTE | #FILE_WRITE_ONCE_MEDIA | #FILE_DEVICE_SECURE_OPEN

;
; Define I/O system data structure type codes. Each major data structure in
; the I/O system has a type code The type field in each structure is at the
; same offset. The following values can be used to determine which type of
; data structure a pointer refers to.
;

#IO_TYPE_ADAPTER=$00000001
#IO_TYPE_CONTROLLER=$00000002
#IO_TYPE_DEVICE=$00000003
#IO_TYPE_DRIVER=$00000004
#IO_TYPE_FILE=$00000005
#IO_TYPE_IRP=$00000006
#IO_TYPE_MASTER_ADAPTER=$00000007
#IO_TYPE_OPEN_PACKET=$00000008
#IO_TYPE_TIMER=$00000009
#IO_TYPE_VPB=$0000000a
#IO_TYPE_ERROR_LOG=$0000000b
#IO_TYPE_ERROR_MESSAGE=$0000000c
#IO_TYPE_DEVICE_OBJECT_EXTENSION=$0000000d


;
; Define the major function codes for IRPs.
;

;
; Make the Scsi major code the same as internal device control.
;

#IRP_MJ_SCSI=#IRP_MJ_INTERNAL_DEVICE_CONTROL

;
; Define the minor function codes for IRPs. The lower 128 codes, from=$00 to
;=$7f are reserved to Microsoft. The upper 128 codes, from=$80 to=$ff, are
; reserved to customers of Microsoft.
;

; end_wdm end_ntndis
;
; Directory control minor function codes
;

#IRP_MN_QUERY_DIRECTORY=$01
#IRP_MN_NOTIFY_CHANGE_DIRECTORY=$02

;
; File system control minor function codes. Note that "user request" is
; assumed to be zero by both the I/O system and file systems. Do not change
; this value.
;

#IRP_MN_USER_FS_REQUEST=$00
#IRP_MN_MOUNT_VOLUME=$01
#IRP_MN_VERIFY_VOLUME=$02
#IRP_MN_LOAD_FILE_SYSTEM=$03
#IRP_MN_TRACK_LINK=$04; To be obsoleted soon
#IRP_MN_KERNEL_CALL=$04

;
; Lock control minor function codes
;

#IRP_MN_LOCK=$01
#IRP_MN_UNLOCK_SINGLE=$02
#IRP_MN_UNLOCK_ALL=$03
#IRP_MN_UNLOCK_ALL_BY_KEY=$04

;
; Read and Write minor function codes for file systems supporting Lan Manager
; software. All of these subfunction codes are invalid if the file has been
; opened with FO_NO_INTERMEDIATE_BUFFERING. They are also invalid in combi-
; nation with synchronous calls (Irp Flag or file open option).
;
; Note that "normal" is assumed to be zero by both the I/O system and file
; systems. Do not change this value.
;

#IRP_MN_NORMAL=$00
#IRP_MN_DPC=$01
#IRP_MN_MDL=$02
#IRP_MN_COMPLETE=$04
#IRP_MN_COMPRESSED=$08

#IRP_MN_MDL_DPC=#IRP_MN_MDL | #IRP_MN_DPC
#IRP_MN_COMPLETE_MDL=#IRP_MN_COMPLETE | #IRP_MN_MDL
#IRP_MN_COMPLETE_MDL_DPC=#IRP_MN_COMPLETE_MDL | #IRP_MN_DPC

; begin_wdm
;
; Device Control request minor function codes for SCSI support. Note that
; user requests are assumed to be zero.
;

#IRP_MN_SCSI_CLASS=$01

;
; PNP minor function codes.
;

#IRP_MN_START_DEVICE=$00
#IRP_MN_QUERY_REMOVE_DEVICE=$01
#IRP_MN_REMOVE_DEVICE=$02
#IRP_MN_CANCEL_REMOVE_DEVICE=$03
#IRP_MN_STOP_DEVICE=$04
#IRP_MN_QUERY_STOP_DEVICE=$05
#IRP_MN_CANCEL_STOP_DEVICE=$06

#IRP_MN_QUERY_DEVICE_RELATIONS=$07
#IRP_MN_QUERY_INTERFACE=$08
#IRP_MN_QUERY_CAPABILITIES=$09
#IRP_MN_QUERY_RESOURCES=$0A
#IRP_MN_QUERY_RESOURCE_REQUIREMENTS=$0B
#IRP_MN_QUERY_DEVICE_TEXT=$0C
#IRP_MN_FILTER_RESOURCE_REQUIREMENTS=$0D

#IRP_MN_READ_CONFIG=$0F
#IRP_MN_WRITE_CONFIG=$10
#IRP_MN_EJECT=$11
#IRP_MN_SET_LOCK=$12
#IRP_MN_QUERY_ID=$13
#IRP_MN_QUERY_PNP_DEVICE_STATE=$14
#IRP_MN_QUERY_BUS_INFORMATION=$15
#IRP_MN_DEVICE_USAGE_NOTIFICATION=$16
#IRP_MN_SURPRISE_REMOVAL=$17
; end_wdm
#IRP_MN_QUERY_LEGACY_BUS_INFORMATION=$18
; begin_wdm

;
; POWER minor function codes
;
#IRP_MN_WAIT_WAKE=$00
#IRP_MN_POWER_SEQUENCE=$01
#IRP_MN_SET_POWER=$02
#IRP_MN_QUERY_POWER=$03

; begin_ntminiport
;
; WMI minor function codes under IRP_MJ_SYSTEM_CONTROL
;

#IRP_MN_QUERY_ALL_DATA=$00
#IRP_MN_QUERY_SINGLE_INSTANCE=$01
#IRP_MN_CHANGE_SINGLE_INSTANCE=$02
#IRP_MN_CHANGE_SINGLE_ITEM=$03
#IRP_MN_ENABLE_EVENTS=$04
#IRP_MN_DISABLE_EVENTS=$05
#IRP_MN_ENABLE_COLLECTION=$06
#IRP_MN_DISABLE_COLLECTION=$07
#IRP_MN_REGINFO=$08
#IRP_MN_EXECUTE_METHOD=$09
; Minor code=$0a is reserved
#IRP_MN_REGINFO_EX=$0b

; end_ntminiport

;
; Define option flags for IoCreateFile. Note that these values must be
; exactly the same as the SL_... flags for a create function. Note also
; that there are flags that may be passed to IoCreateFile that are not
; placed in the stack location for the create IRP. These flags start in
; the next byte.
;

#IO_FORCE_ACCESS_CHECK=$0001
#IO_NO_PARAMETER_CHECKING=$0100

;
; Define Information fields for whether or not a REPARSE or a REMOUNT has
; occurred in the file system.
;

#IO_REPARSE=$0
#IO_REMOUNT=$1

;
; Common dispatcher object header
;
; N.B. The size field contains the number of dwords in the structure.
;

Structure DISPATCHER_HEADER Align #PB_Structure_AlignC ;6 elements, $10 bytes (sizeof)
  ;
  Type.b;00h
  Absolute.b;01h
  Size.b;02h
  Inserted.b;03h
  SignalState.l;04h
  WaitListHead.LIST_ENTRY;08h suivant (08h+8)=10h
  ;
EndStructure
;
;------------------------------------------------------------------------------
;
; Event object
;

Structure KEVENT Align #PB_Structure_AlignC
  Header.DISPATCHER_HEADER
EndStructure
;
;------------------------------------------------------------------------------
;
; Timer object
;

Structure KTIMER Align #PB_Structure_AlignC ;5 elements, $28 bytes (sizeof)
  ;
  Header.DISPATCHER_HEADER;00h $10 bytes
  DueTime.LARGE_INTEGER;10h $08 bytes (2dd ou 1qd)
  TimerListEntry.LIST_ENTRY;18h $08 bytes
  Dpc.i;20h
  
  CompilerIf #PB_Compiler_Processor <> #PB_Processor_x86
    Processor.l
  CompilerEndIf
  
  Period.l;24h suivant 28h
  ;
EndStructure
;
;------------------------------------------------------------------------------
Structure KAPC_STATE Align #PB_Structure_AlignC ;6 elements, $18 bytes (sizeof)
  ApcListHead.LIST_ENTRY[2]
  Process.i;10h
  KernelApcInProgress.b;14h
  KernelApcPending.b;15h
  UserApcPending.b
EndStructure
;
;------------------------------------------------------------------------------
Structure KWAIT_BLOCK Align #PB_Structure_AlignC ;6 elements, $18 bytes (sizeof)
  ;
  WaitListEntry.LIST_ENTRY;00h 2 elements, $8 bytes (sizeof)
  Thread.i;08h
  Object.i;0Ch
  NextWaitBlock.i;10h
  WaitKey.w;14h
  WaitType.a;16h suivant (16h+2)=18h
  BlockState.a
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    SpareLong.l
  CompilerEndIf
EndStructure
;
;------------------------------------------------------------------------------
Structure KSEMAPHORE Align #PB_Structure_AlignC ;2 elements, $14 bytes (sizeof)
  ;
  Header.DISPATCHER_HEADER;00h sizeof 10h
  Limit.l;10h suivant  14h
  ;
EndStructure

Macro RKSEMAPHORE : KSEMAPHORE : EndMacro

;
;------------------------------------------------------------------------------
Structure KDPC Align #PB_Structure_AlignC
  Type.a
  Importance.a
  Number.u  
  DpcListEntry.LIST_ENTRY
  DeferredRoutine.i
  DeferredContext.i
  SystemArgument1.i
  SystemArgument2.i
  DpcData.i
EndStructure
;
;------------------------------------------------------------------------------

CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
  Structure KDEVICE_QUEUE_x64  Align #PB_Structure_AlignC
      Reserved.q ; : 8  <---  .
      Hint.q     ; ; 56 <---  .
  EndStructure
CompilerEndIf


Structure KDEVICE_QUEUE Align #PB_Structure_AlignC
  Type.w
  Size.w  
  DeviceListHead.LIST_ENTRY
  Lock.i
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    StructureUnion
      Busy.b
      x64.KDEVICE_QUEUE_x64
    EndStructureUnion
  CompilerElse
    Busy.b
  CompilerEndIf
EndStructure
;
;------------------------------------------------------------------------------
Structure KDEVICE_QUEUE_ENTRY Align #PB_Structure_AlignC
  DeviceListEntry.LIST_ENTRY
  SortKey.l
  Inserted.b; BOOLEAN
EndStructure
;
;------------------------------------------------------------------------------
Structure WAIT_CONTEXT_BLOCK Align #PB_Structure_AlignC
  WaitQueueEntry.KDEVICE_QUEUE_ENTRY
  DeviceRoutine.i
  DeviceContext.i
  NumberOfMapRegisters.l
  DeviceObject.i
  CurrentIrp.i
  BufferChainingDpc.i
EndStructure
;
;------------------------------------------------------------------------------
Structure DEVICE_OBJECT Align #PB_Structure_AlignC
  Type.w
  Size.w
  ReferenceCount.l
  DriverObject.i
  NextDevice.i
  AttachedDevice.i
  CurrentIrp.i
  Timer.i
  Flags.l; See above: DO_...
  Characteristics.l; See ntioapi: FILE_..
  Vpb.i
  DeviceExtension.i
  DeviceType.i
  StackSize.b  
  
  StructureUnion
    ListEntry.LIST_ENTRY
    Wcb.WAIT_CONTEXT_BLOCK
  EndStructureUnion
  
  AlignmentRequirement.l
  
  Devicequeue.KDEVICE_QUEUE
  Dpc.KDPC
  
  ;
  ; The following field is for exclusive use by the filesystem to keep
  ; track of the number of Fsp threads currently using the device
  ;
  
  ActiveThreadCount.l
  
  SecurityDescriptor.i
  DeviceLock.KEVENT
  SectorSize.w
  Spare1.w  
  DeviceObjectExtension.i
  Reserved.i
EndStructure

Structure DRIVER_EXTENSION
  ;
  ; Back pointer To Driver Object
  ;
  
  *DriverObject.DRIVER_OBJECT
  
  ;
  ; The AddDevice entry point is called by the Plug & Play manager
  ; To inform the driver when a new device instance arrives that this
  ; driver must control.
  ;
  
  *AddDevice.DRIVER_ADD_DEVICE
  
  ;
  ; The count field is used To count the number of times the driver has
  ; had its registered reinitialization routine invoked.
  ;
  
  Count.l
  
  ;
  ; The service name field is used by the pnp manager To determine
  ; where the driver related info is stored in the registry.
  ;
  
  ServiceKeyName.UNICODE_STRING
  
  ;
  ; Note: any new Shared fields get added here.
  ;
  
EndStructure
;
;------------------------------------------------------------------------------
Structure DRIVER_OBJECT Align #PB_Structure_AlignC
  Type.w
  Size.w
  ;
  ; The following links all of the devices created by a single driver
  ; together on a list, and the Flags word provides an extensible flag
  ; location for driver objects.
  ;
  
  *DeviceObject.DEVICE_OBJECT
  Flags.l  
  ;
  ; The following section describes where the driver is loaded. The count
  ; field is used to count the number of times the driver has had its
  ; registered reinitialization routine invoked.
  ;
  
  DriverStart.i
  DriverSize.l
    
  DriverSection.i
  *DriverExtension.DRIVER_EXTENSION
  
  ;
  ; The driver name field is used by the error log thread
  ; determine the name of the driver that an I/O request is/was bound.
  ;
  
  DriverName.UNICODE_STRING
  
  ;
  ; The following section is for registry support. Thise is a pointer
  ; to the path to the hardware information in the registry
  ;
  
  *HardwareDatabase.UNICODE_STRING
  
  ;
  ; The following section contains the optional pointer to an array of
  ; alternate entry points to a driver for "fast I/O" support. Fast I/O
  ; is performed by invoking the driver routine directly with separate
  ; parameters, rather than using the standard IRP call mechanism. Note
  ; that these functions may only be used for synchronous I/O, and when
  ; the file is cached.
  ;
  
  *FastIoDispatch ;.FAST_IO_DISPATCH
  
  ;
  ; The following section describes the entry points to this particular
  ; driver. Note that the major function dispatch table must be the last
  ; field in the object so that it remains extensible.
  ;
  
  *DriverInit ;.DRIVER_INITIALIZE
  *DriverStartIo ;.DRIVER_STARTIO
  *DriverUnload ;.DRIVER_UNLOAD
  *MajorFunction[#IRP_MJ_MAXIMUM_FUNCTION+1]
  
EndStructure; DRIVER_OBJECT
;
;------------------------------------------------------------------------------

;
; Priority increment definitions. The comment for each definition gives
; the names of the system services that use the definition when satisfying
; a wait.
;

;
; Priority increment used when satisfying a wait on an executive event
; (NtPulseEvent and NtSetEvent)
;

#EVENT_INCREMENT=1

;
; Priority increment when no I/O has been done. This is used by device
; and file system drivers when completing an IRP (IoCompleteRequest).
;

#IO_NO_INCREMENT=0


;
; Priority increment for completing CD-ROM I/O. This is used by CD-ROM device
; and file system drivers when completing an IRP (IoCompleteRequest)
;

#IO_CD_ROM_INCREMENT=1

;
; Priority increment for completing disk I/O. This is used by disk device
; and file system drivers when completing an IRP (IoCompleteRequest)
;

#IO_DISK_INCREMENT=1

; end_ntifs

;
; Priority increment for completing keyboard I/O. This is used by keyboard
; device drivers when completing an IRP (IoCompleteRequest)
;

#IO_KEYBOARD_INCREMENT=6

; begin_ntifs
;
; Priority increment for completing mailslot I/O. This is used by the mail-
; slot file system driver when completing an IRP (IoCompleteRequest).
;

#IO_MAILSLOT_INCREMENT=2

; end_ntifs
;
; Priority increment for completing mouse I/O. This is used by mouse device
; drivers when completing an IRP (IoCompleteRequest)
;

#IO_MOUSE_INCREMENT=6

; begin_ntifs
;
; Priority increment for completing named pipe I/O. This is used by the
; named pipe file system driver when completing an IRP (IoCompleteRequest).
;

#IO_NAMED_PIPE_INCREMENT=2

;
; Priority increment for completing network I/O. This is used by network
; device and network file system drivers when completing an IRP
; (IoCompleteRequest).
;

#IO_NETWORK_INCREMENT=2

; end_ntifs
;
; Priority increment for completing parallel I/O. This is used by parallel
; device drivers when completing an IRP (IoCompleteRequest)
;

#IO_PARALLEL_INCREMENT=1

;
; Priority increment for completing serial I/O. This is used by serial device
; drivers when completing an IRP (IoCompleteRequest)
;

#IO_SERIAL_INCREMENT=2

;
; Priority increment for completing sound I/O. This is used by sound device
; drivers when completing an IRP (IoCompleteRequest)
;

#IO_SOUND_INCREMENT=8

;
; Priority increment for completing video I/O. This is used by video device
; drivers when completing an IRP (IoCompleteRequest)
;

#IO_VIDEO_INCREMENT=1

;
; Priority increment used when satisfying a wait on an executive semaphore
; (NtReleaseSemaphore)
;

#SEMAPHORE_INCREMENT=1

;
; Indicates the system may do I/O to physical addresses above 4 GB.
;
;------------------------------------------------------------------------------

Structure IO_STATUS_BLOCK Align #PB_Structure_AlignC
  StructureUnion
    Status.i
    *Pointer
  EndStructureUnion
  Information.i
EndStructure

;------------------------------------------------------------------------------

Structure KAPC Align #PB_Structure_AlignC ;14 elements, sizeof 30h
  
  Type.w;00h
  Size.w;02h
  Spare0.l;04h
  Thread.i;08h
  ApcListEntry.LIST_ENTRY;0Ch
  KernelRoutine.i;14h
  RundownRoutine.i;18h
  NormalRoutine.i;1Ch
  NormalContext.i;20h
  SystemArgument1.i;24h
  SystemArgument2.i;28h
  ApcStateIndex.b;2Ch
  ApcMode.b;2Dh
  Inserted.b;2Eh
  
EndStructure


;- ???? -----------------------------------------------------------------------------

Structure KTHREAD Align #PB_Structure_AlignC
  ;
  Header.DISPATCHER_HEADER;00h sizeof 16h
  MutantListHead.LIST_ENTRY;10h sizeof 08h
  InitialStack.i;18h
  StackLimit.i;1Ch
  Teb.i;20h
  TlsArray.i;24h
  KernelStack.i;28h
  DebugActive.b;2Ch
  State.b;2Dh
  Alerted.b[2];2Eh Alerted[2]BOOLEAN
  Iopl.b;30h
  NpxState.b;31h
  Saturation.b;32h
  Priority.b;33h
  ApcState.KAPC_STATE;34h sizeof 18h
  ContextSwitches.i;4Ch
  IdleSwapBlock.b;50h
  Spare0.b[3];51h Spare0[3]
  WaitStatus.i;54h
  WaitIrql.b;58h
  WaitMode.b;59h
  WaitNext.b;5Ah
  WaitReason.b;5Bh
  WaitBlockList.i;5Ch
  StructureUnion; sizeof=$8 bytes, suivant 68h
    WaitListEntry.LIST_ENTRY;60h 2 elements, $8 bytes (sizeof)
    SwapListEntry.SINGLE_LIST_ENTRY;60h 1 elements, $4 bytes (sizeof)
  EndStructureUnion
  WaitTime.i;68h
  BasePriority.b;6Ch
  DecrementCount.b;6Dh
  PriorityDecrement.b;6Eh
  Quantum.b;6Fh
  WaitBlock.b[$60];70h (4 x sizeof 18h=4xKWAIT_BLOCK)
  LegoData.i;D0h
  KernelApcDisable.i;D4h
  UserAffinity.i;D8h
  SystemAffinityActive.b;DCh BOOLEAN
  PowerState.b;DDh
  NpxIrql.b;DEh
  InitialNode.b;DFh
  ServiceTable.i;E0h
  Queue.i;E4h
  ApcQueueLock.i;E8h
  Timer.KTIMER;F0h sizeof 28h 
  QueueListEntry.LIST_ENTRY;118h sizeof 08h 
  SoftAffinity.i;120h
  Affinity.i;124h
  Preempted.b;128h
  ProcessReadyQueue.b;129h
  KernelStackResident.b;12Ah
  NextProcessor.b;12Bh
  CallbackStack.i;12Ch
  Win32Thread.i;130h
  TrapFrame.i;134h
  ApcStatePointer.i[2];138h ApcStatePointer[2]=2 pointeurs
  PreviousMode.b;140h
  EnableStackSwap.b;141h
  LargeStack.b;142h
  ResourceIndex.b;143h
  KernelTime.i;144h
  UserTime.i;148h
  SavedApcState.KAPC_STATE;14Ch sizeof 18h
  Alertable.b;164h
  ApcStateIndex.b;165h
  ApcQueueable.b;166h
  AutoAlignment.b;167h
  StackBase.i;168h
  SuspendApc.KAPC;16Ch sizeof 30h
  SuspendSemaphore.KSEMAPHORE;19Ch sizeof 14h
  ThreadListEntry.LIST_ENTRY;1B0h sizeof 08h
  FreezeCount.b;1B8h
  SuspendCount.b;1B9h
  IdealProcessor.b;1BAh
  DisableBoost.b;1BBh
  
EndStructure

;- ???? -----------------------------------------------------------------------------

Structure KPROCESS Align #PB_Structure_AlignC ;29 elements, $6C bytes (sizeof)
  ;
  Header.DISPATCHER_HEADER;00h sizeof 10h bytes
  ProfileListHead.LIST_ENTRY;10h sizeof 08h bytes
  DirectoryTableBase.i[2];18h dclar 2 dd
  LdtDescriptor.b[8];20h sizeof 08 bytes (struct KGDTENTRY)
  Int21Descriptor.b[8];28h sizeof 08 bytes (struct KIDTENTRY)
  IopmOffset.w;30h
  Iopl.b;32h
  Unused.b;33h
  ActiveProcessors.i;34h
  KernelTime.i;38h
  UserTime.i;3Ch
  ReadyListHead.LIST_ENTRY;40h sizeof 08h bytes
  SwapListEntry.SINGLE_LIST_ENTRY;48h sizeof 04h bytes
  VdmTrapcHandler.i;4Ch
  ThreadListHead.LIST_ENTRY;50h sizeof o8h bytes
  ProcessLock.i;58h
  Affinity.i;5Ch
  StackCount.w;60h
  BasePriority.b;62h
  ThreadQuantum.b;63h
  AutoAlignment.b;64h
  State.b;65h
  ThreadSeed.b;66h
  DisableBoost.b;67h
  PowerState.b;68h
  Disablequantum.b;69h
  IdealNode.b;6Ah
  StructureUnion
    ;
    Flags.b;6Bh struct KEXECUTE_OPTIONS sizeof 01h byte
    ExecuteOptions.b;6Bh
    ;
  EndStructureUnion
EndStructure;suivant  6Ch

;==========================================================Debut mon _IRP perso

;I/O Request Packet (IRP) definition

Structure _Overlay Align #PB_Structure_AlignC
  
  StructureUnion
    
    ;
    ; DevicequeueEntry - The device queue entry field is used to
    ; queue the IRP to the device driver device queue.
    ;
    
    DevicequeueEntry.KDEVICE_QUEUE_ENTRY
    
    ;Structure
    DriverContext.i[4]
    ;EndStructure
    
  EndStructureUnion
  ;
  ; Thread - pointer to caller's Thread Control Block.
  ;
  
  Thread.i
  
  ;
  ; Auxiliary buffer - pointer to any auxiliary buffer that is
  ; required to pass information to a driver that is not contained
  ; in a normal buffer.
  ;
  
  AuxiliaryBuffer.i
  
  ;
  ; The following unnamed structure must be exactly identical
  ; to the unnamed structure used in the minipacket header used
  ; for completion queue entries.
  ;
  
  ;Structure
  
  ;
  ; List entry - used to queue the packet to completion queue, among
  ; others.
  ;
  
  ListEntry.LIST_ENTRY
  
  StructureUnion
    
    ;
    ; Current stack location - contains a pointer to the current
    ; IO_STACK_LOCATION structure in the IRP stack. This field
    ; should never be directly accessed by drivers. They should
    ; use the standard functions.
    ;
    
    *CurrentStackLocation.IO_STACK_LOCATION
    
    ;
    ; Minipacket type.
    ;
    
    PacketType.l
    
    
  EndStructureUnion
  ;EndStructure
  
  ;
  ; Original file object - pointer to the original file object
  ; that was used to open the file. This field is owned by the
  ; I/O system and should not be used by any other drivers.
  ;
  
  OriginalFileObject.i
  
EndStructure;Overlay

;=======================================================================================

Structure _Tail Align #PB_Structure_AlignC
  StructureUnion
    
    Overlay._Overlay
    
    ;
    ; APC - This APC control block is used for the special kernel APC as
    ; well as for the caller's APC, if one was specified in the original
    ; argument list. If so, then the APC is reused for the normal APC for
    ; whatever mode the caller was in and the "special" routine that is
    ; invoked before the APC gets control simply deallocates the IRP.
    ;
    
    Apc.KAPC
    
    ;
    ; CompletionKey - This is the key that is used to distinguish
    ; individual I/O operations initiated on a single file handle.
    ;
    
    CompletionKey.i
    
  EndStructureUnion;Tail
EndStructure

;========================================================================================


Structure _IRP_union Align #PB_Structure_AlignC
    UserApcRoutine.i
    UserApcContext.i
EndStructure


Structure IRP Align #PB_Structure_AlignC ; j'ai chang "IRP" en "_IRP" ... "IRP" est "utilis par Fasm"
  
  Type.w
  Size.w
  
  
  ;
  ; Define the common fields used to control the IRP.
  ;
  
  ;
  ; Define a pointer to the Memory Descriptor List (MDL) for this I/O
  ; request. This field is only used if the I/O is "direct I/O".
  ;
  
  MdlAddress.i
  
  ;
  ; Flags word - used to remember various flags.
  ;
  
  Flags.l
  
  
  ;
  ; The following union is used for one of three purposes:
  ;
  ; 1. This IRP is an associated IRP. The field is a pointer to a master
  ; IRP.
  ;
  ; 2. This is the master IRP. The field is the count of the number of
  ; IRPs which must complete (associated IRPs) before the master can
  ; complete.
  ;
  ; 3. This operation is being buffered and the field is the address of
  ; the system space buffer.
  ;
  
  StructureUnion
    MasterIrp.i
    IrpCount.l
    SystemBuffer.i
  EndStructureUnion
  
  ;
  ; Thread list entry - allows queueing the IRP to the thread pending I/O
  ; request packet list.
  ;
  
  ThreadListEntry.LIST_ENTRY
  
  ;
  ; I/O status - final status of operation.
  ;
  
  IoStatus.IO_STATUS_BLOCK
  
  ;
  ; Requestor mode - mode of the original requestor of this operation.
  ;
  
  RequestorMode.b
  
  ;
  ; Pending returned - TRUE if pending was initially returned as the
  ; status for this packet.
  ;
  
  PendingReturned.b
  
  ;
  ; Stack state information.
  ;
  
  StackCount.a
  CurrentLocation.a
  
  ;
  ; Cancel - packet has been canceled.
  ;
  
  Cancel.b
  
  ;
  ; Cancel Irql - Irql at which the cancel spinlock was acquired.
  ;
  
  CancelIrql.b
  
  ;
  ; ApcEnvironment - Used to save the APC environment at the time that the
  ; packet was initialized.
  ;
  
  ApcEnvironment.b
  
  ;
  ; Allocation control flags.
  ;
  
  AllocationFlags.a
  
  ;
  ; User parameters.
  ;
  
  UserIosb.i
  UserEvent.i
  
  StructureUnion
    AsynchronousParameters._IRP_union
    AllocationSize.LARGE_INTEGER
  EndStructureUnion
  
  ;
  ; CancelRoutine - Used to contain the address of a cancel routine supplied
  ; by a device driver when the IRP is in a cancelable state.
  ;
  
  CancelRoutine.i
  
  ;
  ; Note that the UserBuffer parameter is outside of the stack so that I/O
  ; completion can copy data back into the user's address space without
  ; having to know exactly which service was being invoked. The length
  ; of the copy is stored in the second half of the I/O status block. If
  ; the UserBuffer field is NULL, then no copy is performed.
  ;
  
  UserBuffer.i
  
  ;
  ; Kernel structures
  ;
  ; The following section contains kernel structures which the IRP needs
  ; in order to place various work information in kernel controller system
  ; queues. Because the size and alignment cannot be controlled, they are
  ; placed here at the end so they just hang off and do not affect the
  ; alignment of other fields in the IRP.
  ;
  
  Tail._Tail
  
  ;testo.i
  
EndStructure

;==========================================================Fin mon "_IRP" perso
;==========================================================Debut mon "IO_STACK_LOCATION" perso



    Structure IO_STACK_LOCATION_Create Align #PB_Structure_AlignC
      SecurityContext.i;04
      Options.l;08
      FileAttributes.w;0C
      ShareAccess.w;0E      
      EaLength.l;10
    EndStructure
    
    Structure IO_STACK_LOCATION_CreatePipe Align #PB_Structure_AlignC
      SecurityContext.i;04
      Options.i;08
      Reserved.w;0C
      ShareAccess01.w;OE
      Parameters.i;10
    EndStructure ; - CreateMailslot
    
    Structure IO_STACK_LOCATION_Read Align #PB_Structure_AlignC
      Length.l;04
      Key.l;08
      ByteOffset.q;0C
    EndStructure ; - Write
    
    Structure IO_STACK_LOCATION_QueryDirectory Align #PB_Structure_AlignC
      Length.l;04
      FileName.i;08
      FileInformationClass.l;0C
      FileIndex.l;10
    EndStructure
    
    Structure IO_STACK_LOCATION_NotifyDirectory Align #PB_Structure_AlignC
      Length.l;04
      CompletionFilter.l;08
    EndStructure
    
    Structure IO_STACK_LOCATION_QueryFile Align #PB_Structure_AlignC
      Length.l;04
      FileInformationClass.l;08
    EndStructure
      
    Structure IO_STACK_LOCATION_SetFile_Str Align #PB_Structure_AlignC
      ReplaceIfExists.b;10
      AdvanceOnly.b;11
     ; _PADDING0_2.b[2];12
    EndStructure
    
    Structure IO_STACK_LOCATION_SetFile Align #PB_Structure_AlignC
      Length.l
      FileInformationClass.l
      FileObject.i
      StructureUnion
        Struct.IO_STACK_LOCATION_SetFile_Str
        ClusterCount.l;10
        DeleteHandle.i;10
      EndStructureUnion
    EndStructure
    
    Structure IO_STACK_LOCATION_QueryEa Align #PB_Structure_AlignC
      Length.l;04
      EaList.i;08
      EaListLength.l;0C
      EaIndex.l;10
    EndStructure
    
    Structure IO_STACK_LOCATION_SetEa Align #PB_Structure_AlignC
      Length.l;04
    EndStructure
    
    Structure IO_STACK_LOCATION_QueryVolume Align #PB_Structure_AlignC
      Length.l;04
      FsInformationClass.l;08
    EndStructure ; - SetVolume
    
    Structure IO_STACK_LOCATION_FileSystemControl Align #PB_Structure_AlignC
      OutputBufferLength.l;04
      InputBufferLength.l;08
      FsControlCode.l;0C
      Type3InputBuffer.i;10
    EndStructure
    
    Structure IO_STACK_LOCATION_LockControl Align #PB_Structure_AlignC
      Length.i;04
      Key.l;08
      ByteOffset.q;0C
    EndStructure
    
    Structure IO_STACK_LOCATION_DeviceIoControl Align #PB_Structure_AlignC
      OutputBufferLength.i;04
      InputBufferLength.i;08
      IoControlCode.i;0C
      Type3InputBuffer.i;10
    EndStructure
    
    Structure IO_STACK_LOCATION_QuerySecurity Align #PB_Structure_AlignC
      SecurityInformation.l;04
      Length.l;08
    EndStructure
    
    Structure IO_STACK_LOCATION_SetSecurity Align #PB_Structure_AlignC
      SecurityInformation.l;04
      SecurityDescriptor.i;08
    EndStructure;
    
    Structure IO_STACK_LOCATION_MountVolume Align #PB_Structure_AlignC
      Vpb.i;04
      DeviceObject.i;08
    EndStructure ; - VerifyVolume
    
    Structure IO_STACK_LOCATION_Scsi Align #PB_Structure_AlignC
      Srb.i;04
    EndStructure
    
    Structure IO_STACK_LOCATION_QueryQuota Align #PB_Structure_AlignC
      Length.l;04
      StartSid.i;08
      SidList.l;0C
      SidListLength.l;10
    EndStructure
    
    Structure IO_STACK_LOCATION_SetQuota Align #PB_Structure_AlignC
      Length.i;04
    EndStructure
    
    Structure IO_STACK_LOCATION_QueryDeviceRelations Align #PB_Structure_AlignC
      Type.l;04
    EndStructure
    
    Structure IO_STACK_LOCATION_QueryInterface Align #PB_Structure_AlignC
      InterfaceType.i;04
      Size.w;08
      Version.w;0A
      *Interface;0C
      *InterfaceSpecificData;10
    EndStructure
    
    Structure IO_STACK_LOCATION_DeviceCapabilities Align #PB_Structure_AlignC
      Capabilities.i;04
    EndStructure
    
    Structure IO_STACK_LOCATION_FilterResourceRequirements Align #PB_Structure_AlignC
      IoResourceRequirementList.i;04
    EndStructure
    
    Structure IO_STACK_LOCATION_ReadWriteConfig Align #PB_Structure_AlignC
      WhichSpace.l;04
      Buffer01.i;08
      Offset.l;0C
      Length.l;10
    EndStructure
    
    Structure IO_STACK_LOCATION_SetLock Align #PB_Structure_AlignC
      Lock.b;04
    EndStructure
    
    Structure IO_STACK_LOCATION_QueryId Align #PB_Structure_AlignC
      IdType.l;04
    EndStructure
    
    Structure IO_STACK_LOCATION_QueryDeviceText Align #PB_Structure_AlignC
      DeviceTextType.l;04
      LocaleId.i;08
    EndStructure
    
    Structure IO_STACK_LOCATION_UsageNotification Align #PB_Structure_AlignC
      InPath.b;04
      Reserved.b[3];05
      Type.i;08
    EndStructure
    
    Structure IO_STACK_LOCATION_WaitWake Align #PB_Structure_AlignC
      PowerState.l;04
    EndStructure
    
    Structure IO_STACK_LOCATION_PowerSequence Align #PB_Structure_AlignC
      PowerSequence.i;04
    EndStructure
    
    Structure IO_STACK_LOCATION_Power Align #PB_Structure_AlignC
      SystemContext.l;04
      Type .l;08
      State .l;0C
      ShutdownType.l;10
    EndStructure
    
    Structure IO_STACK_LOCATION_StartDevice Align #PB_Structure_AlignC
      AllocatedResources .i;04
      AllocatedResourcesTranslated .i;08
    EndStructure
    
    Structure IO_STACK_LOCATION_WMI Align #PB_Structure_AlignC
      ProviderId .l;04
      DataPath .i;08
      BufferSize .l;0C
      Buffer .i;10
    EndStructure
    
    Structure IO_STACK_LOCATION_Others Align #PB_Structure_AlignC
      Argument1 .i;04
      Argument2 .i;08
      Argument3 .i;0C
      Argument4 .i;10
    EndStructure;



    
    Structure IO_STACK_LOCATION_Parameters Align #PB_Structure_AlignC
      StructureUnion
        
        Create.IO_STACK_LOCATION_Create
        CreatePipe.IO_STACK_LOCATION_CreatePipe
        Read.IO_STACK_LOCATION_Read
        QueryDirectory.IO_STACK_LOCATION_QueryDirectory
        NotifyDirectory.IO_STACK_LOCATION_NotifyDirectory
        QueryFile.IO_STACK_LOCATION_QueryFile
        SetFile.IO_STACK_LOCATION_SetFile
        QueryEa.IO_STACK_LOCATION_QueryEa
        SetEa.IO_STACK_LOCATION_SetEa
        QueryVolume.IO_STACK_LOCATION_QueryVolume
        FileSystemControl.IO_STACK_LOCATION_FileSystemControl
        LockControl.IO_STACK_LOCATION_LockControl
        DeviceIoControl.IO_STACK_LOCATION_DeviceIoControl
        QuerySecurity.IO_STACK_LOCATION_QuerySecurity
        SetSecurity.IO_STACK_LOCATION_SetSecurity
        MountVolume.IO_STACK_LOCATION_MountVolume
        Scsi.IO_STACK_LOCATION_Scsi
        QueryQuota.IO_STACK_LOCATION_QueryQuota
        SetQuota.IO_STACK_LOCATION_SetQuota
        QueryDeviceRelations.IO_STACK_LOCATION_QueryDeviceRelations
        QueryInterface.IO_STACK_LOCATION_QueryInterface
        DeviceCapabilities.IO_STACK_LOCATION_DeviceCapabilities
        FilterResourceRequirements.IO_STACK_LOCATION_FilterResourceRequirements
        ReadWriteConfig.IO_STACK_LOCATION_ReadWriteConfig
        SetLock.IO_STACK_LOCATION_SetLock
        QueryId.IO_STACK_LOCATION_QueryId
        QueryDeviceText.IO_STACK_LOCATION_QueryDeviceText
        UsageNotification.IO_STACK_LOCATION_UsageNotification
        WaitWake.IO_STACK_LOCATION_WaitWake
        PowerSequence.IO_STACK_LOCATION_PowerSequence
        Power.IO_STACK_LOCATION_Power
        StartDevice.IO_STACK_LOCATION_StartDevice
        WMI.IO_STACK_LOCATION_WMI
        Others.IO_STACK_LOCATION_Others
        
        
      EndStructureUnion;Parameters
    EndStructure
  
  
Structure IO_STACK_LOCATION Align #PB_Structure_AlignC ;sizeof=24h
  ;
  MajorFunction.a;00
  MinorFunction.a;01
  Flags.a;01
  Control.a;01
  
  Parameters.IO_STACK_LOCATION_Parameters
  
  DeviceObject.i;14
  FileObject .i;18
  CompletionRoutine .i;1C
  Context .i;20
  
EndStructure;IO_STACK_LOCATION;suivant  (20h + 4)=24h


;==========================================================Fin mon "IO_STACK_LOCATION" perso

Structure NT_TIB Align #PB_Structure_AlignC ;8 elements, 1Ch bytes (sizeof) 
  ;
  ExceptionList .i;00h
  StackBase .i;04h
  StackLimit .i;08h
  SubSystemTib .i;0Ch
  ;
  StructureUnion
    FiberData .i;10h
    Version .l;10h
  EndStructureUnion
  ;
  ArbitraryUserPointer .i;14h
  Self .i;18h
  ;
EndStructure;suivant  (18h+4)= 1Ch

;------------------------------------------------------------------------------

Structure DESCRIPTOR Align #PB_Structure_AlignC ;3 elements, $8 bytes (sizeof)
  ;
  Pad .w;00h
  Limit .w;02h
  Base .i;04h
  ;
EndStructure;suivant  08h

;-????-----------------------------------------------------------------------------

Structure _KSPECIAL_REGISTERS Align #PB_Structure_AlignC ;15 elements, $54 bytes (sizeof) 
  ;
  Cr0 .i;00h
  Cr2 .i;04h
  Cr3 .i;08h
  Cr4 .i;0Ch
  KernelDr0 .i;10h
  KernelDr1 .i;14h
  KernelDr2 .i;18h
  KernelDr3 .i;1Ch
  KernelDr6 .i;20h
  KernelDr7 .i;24h
  Gdtr .DESCRIPTOR;28h struct DESCRIPTOR sizeof 08h bytes
  Idtr .DESCRIPTOR;30h
  Tr .w;38h
  Ldtr .w;3Ah
  Reserved .i[6];3Ch Reserved[6],6xdd
  ;
EndStructure;suivant  54h

;-????-----------------------------------------------------------------------------

Structure _CONTEXT Align #PB_Structure_AlignC ;25 elements, $2CC bytes (sizeof)
  ;
  ContextFlags .l;000h
  Dr0 .l;004h
  Dr1 .l;008h
  Dr2 .l;00Ch
  Dr3 .l;010h
  Dr6 .l;014h
  Dr7 .l;018h
  FloatSave .b[$70];01Ch struct FLOATING_SAVE_AREA (sizeof 70h bytes)
  SegGs .l;08Ch
  SegFs .l;090h
  SegEs .l;094h
  SegDs .l;098h
  Edi .l;09Ch
  Esi .l;0A0h
  Ebx .l;0A4h
  Edx .l;0A8h
  Ecx .l;0ACh
  Eax .l;0B0h
  Ebp .l;0B4h
  Eip .l;0B8h
  SegCs .l;0BCh
  EFlags .l;0C0h
  Esp .l;0C4h
  SegSs .l;0C8h
  ExtendedRegisters.b[512];0CCh ExtendedRegisters[512]
  ;
EndStructure;suivant  2CCh
;-????-----------------------------------------------------------------------------

Structure _KPROCESSOR_STATE Align #PB_Structure_AlignC ;2 elements, $320 bytes (sizeof)
  ;
  ContextFrame ._CONTEXT;000h struct _CONTEXT sizeof 2CCh bytes
  SpecialRegisters._KSPECIAL_REGISTERS;2CCh struct _KSPECIAL_REGISTERS (54h bytes)
  ;
EndStructure;suivant (2CCh + 54h)= 320h

;-????-----------------------------------------------------------------------------

Structure KPRCB Align #PB_Structure_AlignC ;91 elements, C50h bytes (sizeof)
  ;
  MinorVersion .w;000h
  MajorVersion .w;002h
  CurrentThread .i;004h;=FS:120h+4=FS:124h
  NextThread .i;008h
  IdleThread .i;00Ch
  Number .b;010h
  Reserved .b;011h
  BuildType .w;012h
  SetMember .i;014h
  CpuType .b;018h
  CpuID .b;019h
  CpuStep .w;01Ah
  ProcessorState ._KPROCESSOR_STATE;01Ch struct _KPROCESSOR_STATE (320h bytes)
  KernelReserved .i[16];33Ch KernelReserved[16], 16(10h) x dd
  HalReserved .i[16];37Ch HalReserved[16], 16(10h) x dd
  PrcbPad0 .b[92];3BCh PrcbPad0[92], 92(5Ch) x db
  LockQueue .b[$80];418h 16x"KSPIN_LOCK_QUEUE"=16x8bytes(80h bytes)
  PrcbPad1 .b[8];498h PrcbPad1[8], 8 x db
  NpxThread .i;4A0h
  InterruptCount .i;4A4h
  KernelTime .i;4A8h
  UserTime .i;4ACh
  DpcTime .i;4B0h
  DebugDpcTime .i;4B4h
  InterruptTime .i;4B8h
  AdjustDpcThreshold.i;4BCh
  PageColor .i;4C0h
  SkipTick .i;4C4h
  MultiThreadSetBusy.b;4C8h
  Spare2 .b[3];4C9h Spare2[3], 3 x db
  ParentNode .i;4CCh
  MultiThreadProcessorSet.i;4D0h
  MultiThreadSetMaster .i;4D4h
  ThreadStartCount .i[2];4D8h ThreadStartCount[2], 2 x dd
  CcFastReadNoWait .i;4E0h
  CcFastReadWait .i;4E4h
  CcFastReadNotPossible .i;4E8h
  CcCopyReadNoWait .i;4ECh
  CcCopyReadWait .i;4F0h
  CcCopyReadNoWaitMiss .i;4F4h
  KeAlignmentFixupCount .i;4F8h
  KeContextSwitches .i;4FCh
  KeDcacheFlushCount .i;500h
  KeExceptionDispatchCount.i;504h
  KeFirstLevelTbFills .i;508h
  KeFloatingEmulationCount.i;50Ch
  KeIcacheFlushCount .i;510h
  KeSecondLevelTbFills .i;514h
  KeSystemCalls .i;518h
  SpareCounter0 .i[1];51Ch SpareCounter0[1], 1 x dd
  PPLookasideList .b[128];520h 16x"PP_LOOKASIDE_LIST"=sizeof 80h
  PPNPagedLookasideList.b[256];5A0h 32x"PP_LOOKASIDE_LIST"=sizeof 100h
  PPPagedLookasideList .b[256];6A0h 32x"PP_LOOKASIDE_LIST"=sizeof 100h
  PacketBarrier .i;7A0h
  ReverseStall .i;7A4h
  IpiFrame .i;7A8h
  PrcbPad2 .b[52];7ACh PrcbPad2[52], 52(34h) x db
  CurrentPacket .i[3];7E0h CurrentPacket[3], 3 x dd
  TargetSet .i;7ECh
  WorkerRoutine .i;7F0h
  IpiFrozen .i;7F4h
  PrcbPad3 .b[40];7F8h PrcbPad3[40], 40(28h) x db
  RequestSummary .i;820h
  SignalDone .i;824h
  PrcbPad4 .b[56];828h PrcbPad4[56], 56(38h) x db
  DpcListHead .LIST_ENTRY;860h 2 elements, $8 bytes (sizeof) 
  DpcStack .i;868h
  DpcCount .i;86Ch
  DpcQueueDepth .i;870h
  DpcRoutineActive .i;874h
  DpcInterruptRequested .i;878h
  DpcLastCount .i;87Ch
  DpcRequestRate .i;880h
  MaximumDpcQueueDepth.i;884h
  MinimumDpcRate .i;888h
  QuantumEnd .i;88Ch
  PrcbPad5 .b[16];890h PrcbPad5[16], 16(10h) x db
  DpcLock .i;8A0h
  PrcbPad6 .b[28];8A4h PrcbPad6[28], 28(1Ch) x db
  CallDpc .b[32];8C0h struct "_KDPC"(sizeof 20h bytes, 9 elem.)
  ChainedInterruptList.i;8E0h
  LookasideIrpFloat .i;8E4h
  SpareFields0 .i[6];8E8h SpareFields0[6], 6 x dd
  VendorString .b[13];900h VendorString[13], 13 x db
  InitialApicId .i;90Dh
  LogicalProcessorsPerPhysicalProcessor .b;90Eh
  MHz .i;910h
  FeatureBits .i;914h
  UpdateSignature .LARGE_INTEGER;918h 8 bytes (sizeof)
  NpxSaveArea .b[$210];920h struct "_FX_SAVE_AREA" 210h bytes sizeof
  PowerState .b[$120];B30h struct "_PROCESSOR_POWER_STATE" 120h bytes sizeof
  ;
EndStructure;suivant  (B30h+120h)=C50h

;-????-----------------------------------------------------------------------------

Structure KPCR Align #PB_Structure_AlignC ;27 elements, $D70 bytes (sizeof) en principe,  fs:0
  ;
  NtTib .NT_TIB;000h
  SelfPcr .i;01Ch; FFDFF000h
  Prcb .i;020h
  Irql .b;024h
  IRR .i;028h
  IrrActive .i;02Ch
  IDR .i;030h
  KdVersionBlock .i;034h
  IDT .i;038h
  GDT .i;03Ch
  TSS .i;040h
  MajorVersion .w;044h
  MinorVersion .w;046h
  SetMember .i;048h
  StallScaleFactor .i;04Ch 
  DebugActive .b;050h
  Number .b;051h
  Spare0 .b;052h
  SecondLevelCacheAssociativity .b;053h 
  VdmAlert .i;054h
  KernelReserved .i[14];058h 58h + (0Eh x 4)=90h
  SecondLevelCacheSize .i;090h
  HalReserved .i[16];094h 94h + (10h x 4)=D4h
  InterruptMode .i;0D4h
  Spare1 .b;0D8h
  KernelReserved2 .i[17];0DCh DCh + (11h x 4)=120h
  PrcbData .KPRCB;120h sizeof=0C50h
  ;
EndStructure;suivant  (120h + C50h)=D70h

;------------------------------------------------------------------------------





Enumeration 0
  #KeyValueBasicInformation
  #KeyValueFullInformation
  #KeyValuePartialInformation
  #KeyValueFullInformationAlign64
  #KeyValuePartialInformationAlign64
  #MaxKeyValueInfoClass
EndEnumeration



#SystemInformationClassMin	=0	
#SystemBasicInformation	=0	
#SystemProcessorInformation	=1	
#SystemPerformanceInformation	=2	
#SystemTimeOfDayInformation	=3	
#SystemPathInformation	=4	
#SystemNotImplemented1	=4	
#SystemProcessInformation	=5	
#SystemProcessesAndThreadsInformation	=5	
#SystemCallCountInfoInformation	=6	
#SystemCallCounts	=6	
#SystemDeviceInformation	=7	
#SystemConfigurationInformation	=7	
#SystemProcessorPerformanceInformation	=8	
#SystemProcessorTimes	=8	
#SystemFlagsInformation	=9	
#SystemGlobalFlag	=9	
#SystemCallTimeInformation	=10	
#SystemNotImplemented2	=10	
#SystemModuleInformation	=11	
#SystemLocksInformation	=12	
#SystemLockInformation	=12	
#SystemStackTraceInformation	=13	
#SystemNotImplemented3	=13	
#SystemPagedPoolInformation	=14	
#SystemNotImplemented4	=14	
#SystemNonPagedPoolInformation	=15	
#SystemNotImplemented5	=15	
#SystemHandleInformation	=16	
#SystemObjectInformation	=17	
#SystemPageFileInformation	=18	
#SystemPageFileInformation	=18	
#SystemVdmInstemulInformation	=19	
#SystemInstructionEmulationCounts	=19	
#SystemVdmBopInformation	=20	
#SystemInvalidInfoClass1	=20	
#SystemFileCacheInformation	=21	
#SystemCacheInformation	=21	
#SystemPoolTagInformation	=22	
#SystemInterruptInformation	=23	
#SystemProcessorStatistics	=23	
#SystemDpcBehaviourInformation	=24	
#SystemDpcInformation	=24	
#SystemFullMemoryInformation	=25	
#SystemNotImplemented6	=25	
#SystemLoadImage	=26	
#SystemUnloadImage	=27	
#SystemTimeAdjustmentInformation	=28	
#SystemTimeAdjustment	=8	
#SystemSummaryMemoryInformation	=29	
#SystemNotImplemented7	=29	
#SystemNextEventIdInformation	=30	
#SystemNotImplemented8	=30	
#SystemEventIdsInformation	=31	
#SystemNotImplemented9	=31	
#SystemCrashDumpInformation	=32	
#SystemExceptionInformation	=33	
#SystemCrashDumpStateInformation	=34	
#SystemKernelDebuggerInformation	=35	
#SystemContextSwitchInformation	=36	
#SystemRegistryQuotaInformation =	37	
#SystemLoadAndCallImage =	38	
#SystemPrioritySeparation =	39	
#SystemPlugPlayBusInformation =	40	
#SystemNotImplemented10 =	40	
#SystemDockInformation =	41	
#SystemNotImplemented11 =	41	
#SystemInvalidInfoClass2 =	42	
#SystemProcessorSpeedInformation =	43	
#SystemInvalidInfoClass3 =	43	
#SystemCurrentTimeZoneInformation =	44	
#SystemTimeZoneInformation =	44	
#SystemLookasideInformation =	45	
#SystemSetTimeSlipEvent =	46	
#SystemCreateSession =	47	
#SystemDeleteSession =	48	
#SystemInvalidInfoClass4 =	49	
#SystemRangeStartInformation =	50	
#SystemVerifierInformation =	51	
#SystemAddVerifier =	52	
#SystemSessionProcessesInformation	= 53	
#SystemInformationClassMax =	54

Enumeration 0
  #MmNonCached
  #MmCached
  #MmWriteCombined
  #MmHardwareCoherentCached
  #MmNonCachedUnordered
  #MmUSWCCached
  #MmMaximumCacheType
EndEnumeration

Enumeration
  #MmSmallSystem
  #MmMediumSystem
  #MmLargeSystem
EndEnumeration



CompilerIf Defined(SYSTEM_MODULE_INFORMATION, #PB_Structure)=0
  Structure SYSTEM_MODULE_INFORMATION Align #PB_Structure_AlignC
    Reserved.l[2]
    *Base
    Size.l
    Flags.l
    Index.u
    Unknown.u
    LoadCount.u
    ModuleNameOffset.u
    ImageName.c[256]
  EndStructure
CompilerEndIf

CompilerIf Defined(KEY_VALUE_PARTIAL_INFORMATION, #PB_Structure)=0
  Structure KEY_VALUE_PARTIAL_INFORMATION Align #PB_Structure_AlignC
    TitleIndex.l
    Type.l
    DataLength.l
    Data.a[1]
  EndStructure
CompilerEndIf


Structure RTL_QUERY_REGISTRY_TABLE Align #PB_Structure_AlignC
  *QueryRoutine
  Flags.l
  *Name
  *EntryContext
  DefaultType.l
  *DefaultData
  DefaultLength.l
EndStructure

Structure TIME_FIELDS Align #PB_Structure_AlignC
  Year.u
  Month.u
  Day.u
  Hour.u
  Minute.u
  Second.u
  Milliseconds.u
  Weekday.u
EndStructure

; Structure RTL_OSVERSIONINFOEXW Align #PB_Structure_AlignC
;   dwOSVersionInfoSize.l
;   dwMajorVersion.l
;   dwMinorVersion.l
;   UdwBuildNumber.l
;   dwPlatformId.l
;   szCSDVersion.u[128];
;   wServicePackMajor.u
;   wServicePackMinor.u
;   wSuiteMask.u
;   wProductType.a
;   wReserved.a
; EndStructure



Structure RTL_OSVERSIONINFOW Align #PB_Structure_AlignC
  dwOSVersionInfoSize.l
  dwMajorVersion.l
  dwMinorVersion.l
  dwBuildNumber.l
  dwPlatformId.l
  szCSDVersion.u[128]
EndStructure

Structure RTL_OSVERSIONINFOEXW Extends RTL_OSVERSIONINFOW Align #PB_Structure_AlignC
  wServicePackMajor.u
  wServicePackMinor.u
  wSuiteMask.u
  wProductType.a
  wReserved.a
EndStructure
  

Macro UUID:GUID:EndMacro
Macro PHYSICAL_ADDRESS :LARGE_INTEGER : EndMacro
Macro SECURITY_DESCRIPTOR_CONTROL:l: EndMacro

Structure FILE_OBJECT Align #PB_Structure_AlignC
  Type.u
  Size.u
  *DeviceObject.DEVICE_OBJECT 
  *Vpb
  *FsContext
  *FsContext2
  *SectionObjectPointer.SECTION_OBJECT_POINTERS
  *PrivateCacheMap
  FinalStatus.i
  *RelatedFileObject.FILE_OBJECT
  LockOperation.b
  DeletePending.b
  ReadAccess.b
  WriteAccess.b
  DeleteAccess.b
  SharedRead.b
  SharedWrite.b
  SharedDelete.b
  Flags.l
  FileName.UNICODE_STRING
  CurrentByteOffset.LARGE_INTEGER
  Waiters.l
  Busy.l
  *LastLock
  Lock.KEVENT
  Event.KEVENT
  *CompletionContext.IO_COMPLETION_CONTEXT
  *IrpListLock
  IrpList.LIST_ENTRY
  *FileObjectExtension
EndStructure

Enumeration 0
  #PARTITION_STYLE_MBR
  #PARTITION_STYLE_GPT
  #PARTITION_STYLE_RAW
EndEnumeration

Structure CREATE_DISK_MBR Align #PB_Structure_AlignC
  Signature.l
EndStructure

Structure CREATE_DISK_GPT Align #PB_Structure_AlignC
  DiskId.GUID
  MaxPartitionCount.l
EndStructure

Structure CREATE_DISK Align #PB_Structure_AlignC
  PartitionStyle.l
  StructureUnion
    Mbr.CREATE_DISK_MBR
    Gpt.CREATE_DISK_GPT
  EndStructureUnion
EndStructure

Structure CONFIGURATION_INFORMATION Align #PB_Structure_AlignC
  DiskCount.l        ; Count of hard disks thus far
  FloppyCount.l      ; Count of floppy disks thus far
  CdRomCount.l       ; Count of CD-ROM drives thus far
  TapeCount.l        ; Count of tape drives thus far
  ScsiPortCount.l    ; Count of SCSI port adapters thus far
  SerialCount.l      ; Count of serial devices thus far
  ParallelCount.l    ; Count of parallel devices thus far
  
  AtDiskPrimaryAddressClaimed.b
  AtDiskSecondaryAddressClaimed.b
  
  Version.l
  MediumChangerCount.l
EndStructure


Structure DISK_SIGNATURE_Mbr Align #PB_Structure_AlignC
  Signature.l
  CheckSum.l
EndStructure

Structure DISK_SIGNATURE_Gpt Align #PB_Structure_AlignC
  DiskId.GUID 
EndStructure

Structure DISK_SIGNATURE Align #PB_Structure_AlignC
  PartitionStyle.l
  StructureUnion
    Mbr.DISK_SIGNATURE_Mbr
    Gpt.DISK_SIGNATURE_Gpt
  EndStructureUnion
EndStructure

Structure PARTITION_INFORMATION Align #PB_Structure_AlignC
  StartingOffset.LARGE_INTEGER
  PartitionLength.LARGE_INTEGER
  HiddenSectors.l
  PartitionNumber.l
  PartitionType.a
  BootIndicator.b
  RecognizedPartition.b
  RewritePartition.b
EndStructure

Structure SHARE_ACCESS Align #PB_Structure_AlignC
  OpenCount.l
  Readers.l
  Writers.l
  Deleters.l
  SharedRead.l
  SharedWrite.l
  SharedDelete.l
EndStructure

Structure DRIVE_LAYOUT_INFORMATION_MBR Align #PB_Structure_AlignC
  Signature.l
EndStructure

Structure DRIVE_LAYOUT_INFORMATION_GPT Align #PB_Structure_AlignC
  DiskId.GUID
  StartingUsableOffset.LARGE_INTEGER
  UsableLength.LARGE_INTEGER
  MaxPartitionCount.l
EndStructure

Structure PARTITION_INFORMATION_MBR Align #PB_Structure_AlignC
  PartitionType.a
  BootIndicator.b
  RecognizedPartition.b
  HiddenSectors.l
EndStructure

Structure PARTITION_INFORMATION_GPT Align #PB_Structure_AlignC
  PartitionType.GUID
  PartitionId.GUID
  Attributes.q
  Name.u[36]
EndStructure

Structure PARTITION_INFORMATION_EX Align #PB_Structure_AlignC
  PartitionStyle.l
  StartingOffset.LARGE_INTEGER
  PartitionLength.LARGE_INTEGER
  PartitionNumber.l
  RewritePartition.b
  StructureUnion
    Mbr.PARTITION_INFORMATION_MBR
    Gpt.PARTITION_INFORMATION_GPT
  EndStructureUnion
EndStructure

Structure DRIVE_LAYOUT_INFORMATION_EX Align #PB_Structure_AlignC
  PartitionStyle.l
  PartitionCount.l
  StructureUnion
    Mbr.DRIVE_LAYOUT_INFORMATION_MBR
    Gpt.DRIVE_LAYOUT_INFORMATION_GPT
  EndStructureUnion
  PartitionEntry.PARTITION_INFORMATION_EX[1]
EndStructure

Structure KBUGCHECK_CALLBACK_RECORD Align #PB_Structure_AlignC
  Entry.LIST_ENTRY
  *CallbackRoutine
  *Buffer
  Length.l
  *Component
  Checksum.i
  State.a
EndStructure

Structure KFLOATING_SAVE Align #PB_Structure_AlignC
  ControlWord.l
  StatusWord.l
  ErrorOffset.l
  ErrorSelector.l
  DataOffset.l
  DataSelector.l
  Cr0NpxState.l
  Spare1.l
EndStructure

Structure SECURITY_SUBJECT_CONTEXT Align #PB_Structure_AlignC
  *ClientToken.ACCESS_TOKEN
  ImpersonationLevel.l
  *PrimaryToken.ACCESS_TOKEN
  *ProcessAuditId
EndStructure

Structure FILE_NETWORK_OPEN_INFORMATION Align #PB_Structure_AlignC
  CreationTime.LARGE_INTEGER
  LastAccessTime.LARGE_INTEGER
  LastWriteTime.LARGE_INTEGER
  ChangeTime.LARGE_INTEGER
  AllocationSize.LARGE_INTEGER
  EndOfFile.LARGE_INTEGER
  FileAttributes.l
EndStructure

Structure SLIST_HEADER_1 Align #PB_Structure_AlignC
  _Next.SINGLE_LIST_ENTRY
  Depth.u
  Sequence.u
EndStructure

Structure SLIST_HEADER Align #PB_Structure_AlignC
  StructureUnion
    Alignment.q
    s.SLIST_HEADER_1
  EndStructureUnion
EndStructure

Structure GENERAL_LOOKASIDE Align #PB_Structure_AlignC
  StructureUnion
    ListHead.SLIST_HEADER
    SingleListHead.SINGLE_LIST_ENTRY
  EndStructureUnion
  Depth.u
  MaximumDepth.u
  TotalAllocates.l
  StructureUnion
    AllocateMisses.l
    AllocateHits.l
  EndStructureUnion
  TotalFrees.l
  StructureUnion
    FreeMisses.l
    FreeHits.l
  EndStructureUnion
  Type.l
  Tag.l
  Size.l
  StructureUnion
    *AllocateEx.ALLOCATE_FUNCTION_EX
    *Allocate.ALLOCATE_FUNCTION
  EndStructureUnion
  StructureUnion
    *FreeEx.FREE_FUNCTION_EX
    *Free.FREE_FUNCTION
  EndStructureUnion
  ListEntry.LIST_ENTRY
  LastTotalAllocates.l
  StructureUnion
    LastAllocateMisses.l
    LastAllocateHits.l
  EndStructureUnion
  Future.l[2]
EndStructure

Structure FAST_MUTEX
  Count.l
  *Owner.KTHREAD
  Contention.l
  Gate.KEVENT
  OldIrql.l
EndStructure

Structure PAGED_LOOKASIDE_LIST Align #PB_Structure_AlignC
  L.GENERAL_LOOKASIDE
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
    Lock__ObsoleteButDoNotDelete.FAST_MUTEX
  CompilerEndIf
EndStructure

Structure EX_PUSH_LOCK Align #PB_Structure_AlignC
  StructureUnion
    ;Locked.l
    ;Waiting.l
    Value.l
    *Ptr
  EndStructureUnion
EndStructure

Structure EX_RUNDOWN_REF Align #PB_Structure_AlignC
  StructureUnion
    Count.l
    *Ptr
  EndStructureUnion
EndStructure

Structure EX_FAST_REF Align #PB_Structure_AlignC
  StructureUnion
    *Object
    Value.l
  EndStructureUnion
EndStructure

Structure HARDWARE_PTE Align #PB_Structure_AlignC
  StructureUnion
    Valid.l
    LowPart.l
  EndStructureUnion
  HighPart.l
EndStructure

Structure OBJECT_NAME_INFORMATION Align #PB_Structure_AlignC
  Name.UNICODE_STRING
EndStructure

Structure SE_AUDIT_PROCESS_CREATION_INFO Align #PB_Structure_AlignC
  *ImageFileName.OBJECT_NAME_INFORMATION
EndStructure

Structure MMSUPPORT_FLAGS Align #PB_Structure_AlignC
  BitBlock_1.l
  
;   SessionSpace.l ;: 1
;   ModwriterAttached.l ;: 1
;   TrimHard.l ;: 1
;   MaximumWorkingSetHard.l ;: 1
;   ForceTrim.l;: 1
;   MinimumWorkingSetHard.l ;: 1
;   SessionMaster.l ;: 1
;   TrimmerAttached.l ;: 1
;   TrimmerDetaching.l ;: 1
;   Reserved.l ;: 7
;   MemoryPriority.l ;: 8
;   WsleDeleted.l ;: 1
;   VmExiting.l ;: 1
;   Available.l ;: 6
EndStructure

Structure MMSUPPORT Align #PB_Structure_AlignC
  WorkingSetExpansionLinks.LIST_ENTRY
  LastTrimStamp.w
  NextPageColor.w
  Flags.MMSUPPORT_FLAGS 
  PageFaultCount.l
  PeakWorkingSetSize.l
  Spare0.l
  MinimumWorkingSetSize.l
  MaximumWorkingSetSize.l
  *VmWorkingSetList.MMWSL
  Claim.l
  Spare.l[1]
  WorkingSetPrivateSize.l
  WorkingSetSizeOverhead.l
  WorkingSetSize.l
  *ExitEvent.KEVENT
  WorkingSetMutex.EX_PUSH_LOCK
  *AccessLog
EndStructure

Structure MMADDRESS_NODE Align #PB_Structure_AlignC
  u1.l
  *LeftChild.MMADDRESS_NODE
  *RightChild.MMADDRESS_NODE
  StartingVpn.l
  EndingVpn.l
EndStructure

Structure MM_AVL_TABLE Align #PB_Structure_AlignC
  BalancedRoo.MMADDRESS_NODE
;   DepthOfTree.l ;: 5
;   Unused.l ;: 3
;   NumberGenericTableElements.l ;: 24
  BitBlock_1.l
  *NodeHint
  *NodeFreeHint
EndStructure

Structure ALPC_PROCESS_CONTEXT Align #PB_Structure_AlignC
  Lock.EX_PUSH_LOCK
  ViewListHead.LIST_ENTRY
  PagedPoolQuotaCache.l
EndStructure

Structure EPROCESS_sub Align #PB_Structure_AlignC
  SubSystemMinorVersion.a
  SubSystemMajorVersion.a
EndStructure

Structure EPROCESS Align #PB_Structure_AlignC
  Pcb.KPROCESS
  ProcessLock.EX_PUSH_LOCK
  CreateTime.LARGE_INTEGER
  ExitTime.LARGE_INTEGER
  RundownProtect.EX_RUNDOWN_REF
  *UniqueProcessId
  ActiveProcessLinks.LIST_ENTRY
  QuotaUsage.l[3]
  QuotaPeak.l[3]
  CommitCharge.l
  PeakVirtualSize.l
  VirtualSize.l
  SessionProcessLinks.LIST_ENTRY
  *DebugPort;
  StructureUnion
    *ExceptionPortData
    ExceptionPortValue.l
    ExceptionPortState.l ; : 3;
  EndStructureUnion
  *ObjectTable.HANDLE_TABLE
  Token.EX_FAST_REF
  WorkingSetPage.l
  AddressCreationLock.EX_PUSH_LOCK
  *RotateInProgress.ETHREAD
  *ForkInProgress.ETHREAD
  HardwareTrigger.l
  *PhysicalVadRoot.MM_AVL_TABLE
  *CloneRoot
  NumberOfPrivatePages.l
  NumberOfLockedPages.l
  *Win32Process
  *Job.EJOB
  *SectionObject
  *SectionBaseAddress
  *QuotaBlock
  *WorkingSetWatch
  *Win32WindowStation
  *InheritedFromUniqueProcessId
  *LdtInformation
  *VadFreeHint
  *VdmObjects
  *DeviceMap
  *EtwDataSource
  *FreeTebHint
  StructureUnion
    PageDirectoryPte.HARDWARE_PTE
    Filler.q
  EndStructureUnion
  *Session
  ImageFileName.a[16]
  JobLinks.LIST_ENTRY
  *LockedPagesList
  ThreadListHead.LIST_ENTRY
  *SecurityPort
  *PaeTop
  ActiveThreads.l
  ImagePathHash.l
  DefaultHardErrorProcessing.l
  LastThreadExitStatus.l
  *Peb.PEB
  PrefetchTrace.EX_FAST_REF
  ReadOperationCount.LARGE_INTEGER
  WriteOperationCount.LARGE_INTEGER
  OtherOperationCount.LARGE_INTEGER
  ReadTransferCount.LARGE_INTEGER
  WriteTransferCount.LARGE_INTEGER
  OtherTransferCount.LARGE_INTEGER
  CommitChargeLimit.l
  CommitChargePeak.l
  *AweInfo
  SeAuditProcessCreationInfo.SE_AUDIT_PROCESS_CREATION_INFO
  Vm.MMSUPPORT
  MmProcessLinks.LIST_ENTRY
  ModifiedPageCount.l
  Flags2.l
;   JobNotReallyActive.l ;: 1
;   AccountingFolded.l ;: 1
;   NewProcessReported.l ;: 1
;   ExitProcessReported.l ;: 1
;   ReportCommitChanges.l ;: 1
;   LastReportMemory.l ;: 1
;   ReportPhysicalPageChanges.l ;: 1
;   HandleTableRundown.l ;: 1
;   NeedsHandleRundown.l ;: 1
;   RefTraceEnabled.l ;: 1
;   NumaAware.l ;: 1
;   ProtectedProcess.l ;: 1
;   DefaultPagePriority.l ;: 3
;   PrimaryTokenFrozen.l ;: 1
;   ProcessVerifierTarget.l ;: 1
;   StackRandomizationDisabled.l ;: 1

  BitBlock_1.l ; contains bits 'JobNotReallyActive' to 'StackRandomizationDisabled'

  Flags.l
;   CreateReported.l  ;: 1
;   NoDebugInherit.l ;: 1
;   ProcessExiting.l ;: 1
;   ProcessDelete.l ;: 1
;   Wow64SplitPages.l ;: 1
;   VmDeleted.l ;: 1
;   OutswapEnabled.l ;: 1
;   Outswapped.l ;: 1
;   ForkFailedl.l ;: 1
;   Wow64VaSpace4Gb.l ;: 1
;   AddressSpaceInitialized.l ;: 2
;   SetTimerResolution.l ;: 1
;   BreakOnTermination.l ;: 1
;   DeprioritizeViews.l ;: 1
;   WriteWatch.l ;: 1
;   ProcessInSession.l ;: 1
;   OverrideAddressSpace.l ;: 1
;   HasAddressSpace.l ;: 1
;   LaunchPrefetched.l ;: 1
;   InjectInpageErrors.l ;: 1
;   VmTopDown.l ;: 1
;   ImageNotifyDone.l ;: 1
;   PdeUpdateNeeded.l ;: 1
;   VdmAllowed.l ;: 1
;   SmapAllowed.l ;: 1
;   ProcessInserted.l ;: 1
;   DefaultIoPriority.l ;: 3
;   SparePsFlags1.l ;: 2

  BitBlock_2.l ; contains bits 'CreateReported' to 'SparePsFlags1'

  ExitStatus.l
  Spare7.w
  StructureUnion
    sub.EPROCESS_sub 
    SubSystemVersion.w
  EndStructureUnion
  PriorityClass.a
  VadRoot.MM_AVL_TABLE
  Cookie.l
  AlpcContext.ALPC_PROCESS_CONTEXT
EndStructure


Structure KMUTANT Align #PB_Structure_AlignC
  Header.DISPATCHER_HEADER
  MutantListEntry.LIST_ENTRY
  *OwnerThread.KTHREAD
  Abandoned.b
  ApcDisable.a
EndStructure
  
Macro KMUTEX : KMUTANT : EndMacro

Enumeration
  #Executive
  #FreePage
  #PageIn
  #PoolAllocation
  #DelayExecution
  #Suspended
  #UserRequest
  #WrExecutive
  #WrFreePage
  #WrPageIn
  #WrPoolAllocation
  #WrDelayExecution
  #WrSuspended
  #WrUserRequest
  #WrEventPair
  #WrQueue
  #WrLpcReceive
  #WrLpcReply
  #WrVirtualMemory
  #WrPageOut
  #WrRendezvous
  #WrKeyedEvent
  #WrTerminated
  #WrProcessInSwap
  #WrCpuRateControl
  #WrCalloutStack
  #WrKernel
  #WrResource
  #WrPushLock
  #WrMutex
  #WrQuantumEnd
  #WrDispatchInt
  #WrPreempted
  #WrYieldExecution
  #WrFastMutex
  #WrGuardedMutex
  #WrRundown
  #MaximumWaitReason
EndEnumeration

Structure KINTERRUPT Align #PB_Structure_AlignC
  Type.w
  Size.w
  InterruptListEntry.LIST_ENTRY
  *ServiceRoutine.Acsii
  *MessageServiceRoutine.ascii
  MessageIndex.l
  *ServiceContext
  SpinLock.l
  TickCount.l
  *ActualLock.Long
  *DispatchAddress
  Vector.l
  Irql.a
  SynchronizeIrql.a
  FloatingSave.a
  Connected.a
  Number.b
  ShareVector.a
  Mode.a
  Polarity.a
  ServiceCount.l
  DispatchCount.l
  Rsvd1.q
  DispatchCode.l[135]
EndStructure

Enumeration ; _KINTERRUPT_MODE
  #LevelSensitive
  #Latched
EndEnumeration


Structure OBJECT_HANDLE_FLAG_INFORMATION Align #PB_Structure_AlignC
  Inherit.b
  ProtectFromClose.b
EndStructure


Macro ACCESS_MASK:l:EndMacro

Structure OBJECT_BASIC_INFORMATION Align #PB_Structure_AlignC
  Attributes.l
  DesiredAccess.ACCESS_MASK
  HandleCount.l
  ReferenceCount.l
  PagedPoolUsage.l
  NonPagedPoolUsage.l
  Reserved.l[3]
  NameInformationLength.l
  TypeInformationLength.l
  SecurityDescriptorLength.l
  CreationTime.LARGE_INTEGER
EndStructure

Structure SYSTEM_HANDLE_TABLE_ENTRY_INFO Align #PB_Structure_AlignC
  UniqueProcessId.u
  CreatorBackTraceIndex.u
  ObjectTypeIndex.a
  HandleAttributes.a
  HandleValue.u
  *Object
  GrantedAccess.l
EndStructure

Structure SYSTEM_HANDLE Align #PB_Structure_AlignC
  ProcessId.l
  ObjectTypeNumber.b
  Flags.b
  Handle.u
  *Object
  GrantedAccess.l
EndStructure

Structure SYSTEM_HANDLE_INFORMATION Align #PB_Structure_AlignC
  NumberOfHandles.l;q
  Handles.SYSTEM_HANDLE[1];SYSTEM_HANDLE_TABLE_ENTRY_INFO[1]
EndStructure

Enumeration
  #ObjectBasicInformation
  #ObjectNameInformation
  #ObjectTypeInformation
  #ObjectAllInformation
  #ObjectDataInformation
EndEnumeration

Structure OBJECT_TYPE_INFORMATION Align #PB_Structure_AlignC
  Name.UNICODE_STRING
  TotalNumberOfObjects.l
  TotalNumberOfHandles.l
  TotalPagedPoolUsage.l
  TotalNonPagedPoolUsage.l
  TotalNamePoolUsage.l
  TotalHandleTableUsage.l
  HighWaterNumberOfObjects.l
  HighWaterNumberOfHandles.l
  HighWaterPagedPoolUsage.l
  HighWaterNonPagedPoolUsage.l
  HighWaterNamePoolUsage.l
  HighWaterHandleTableUsage.l
  InvalidAttributes.l
  GenericMapping.GENERIC_MAPPING
  ValidAccess.l
  SecurityRequired.b
  MaintainHandleCount.b
  MaintainTypeList.u
  PoolType.b
  PagedPoolUsage.l
  NonPagedPoolUsage.l
EndStructure
; IDE Options = PureBasic 5.11 (Windows - x64)
; CursorPosition = 3086
; FirstLine = 3061
; Folding = --
; EnableXP
; DisableDebugger
; CompileSourceDirectory
; EnableBuildCount = 0
; EnableExeConstant