CompilerIf Defined(PB_WINSDK_NTDLL_H, #PB_Constant) = 0
#PB_WINSDK_NTDLL_H = 1

;-ENUMS
Enumeration ;// typedef enum _SYSTEMINFOCLASS
	#SystemBasicInformation             ; 0x002C
	#SystemProcessorInformation         ; 0x000C
	#SystemPerformanceInformation       ; 0x0138
	#SystemTimeInformation              ; 0x0020
	#SystemPathInformation              ; Not implemented
	#SystemProcessInformation           ; 0x00C8+ per process
	#SystemCallInformation              ; 0x0018 + (n * 0x0004)
	#SystemConfigurationInformation     ; 0x0018
	#SystemProcessorCounters            ; 0x0030 per cpu
	#SystemGlobalFlag                   ; 0x0004 (fails If size != 4)
	#SystemCallTimeInformation          ; Not implemented
	#SystemModuleInformation            ; 0x0004 + (n * 0x011C)
	#SystemLockInformation              ; 0x0004 + (n * 0x0024)
	#SystemStackTraceInformation        ; Not implemented
	#SystemPagedPoolInformation         ; checked build only
	#SystemNonPagedPoolInformation      ; checked build only
	#SystemHandleInformation            ; 0x0004  + (n * 0x0010)
	#SystemObjectTypeInformation        ; 0x0038+ + (n * 0x0030+)
	#SystemPageFileInformation          ; 0x0018+ per page file
	#SystemVdmInstemulInformation       ; 0x0088
	#SystemVdmBopInformation            ; invalid info class
	#SystemCacheInformation             ; 0x0024
	#SystemPoolTagInformation           ; 0x0004 + (n * 0x001C)
	#SystemInterruptInformation         ; 0x0000 Or 0x0018 per cpu
	#SystemDpcInformation               ; 0x0014
	#SystemFullMemoryInformation        ; checked build only
	#SystemLoadDriver                   ; 0x0018 set mode only
	#SystemUnloadDriver                 ; 0x0004 set mode only
	#SystemTimeAdjustmentInformation    ; 0x000C 0x0008 writeable
	#SystemSummaryMemoryInformation     ; checked build only
	#SystemNextEventIdInformation       ; checked build only
	#SystemEventIdsInformation          ; checked build only
	#SystemCrashDumpInformation         ; 0x0004
	#SystemExceptionInformation         ; 0x0010
	#SystemCrashDumpStateInformation    ; 0x0004
	#SystemDebuggerInformation          ; 0x0002
	#SystemContextSwitchInformation     ; 0x0030
	#SystemRegistryQuotaInformation     ; 0x000C
	#SystemAddDriver                    ; 0x0008 set mode only
	#SystemPrioritySeparationInformation; 0x0004 set mode only
	#SystemPlugPlayBusInformation       ; Not implemented
	#SystemDockInformation              ; Not implemented
	#SystemPowerInfo                     ; 0x0060 (XP only!)
	#SystemProcessorSpeedInformation    ; 0x000C (XP only!)
	#SystemTimeZoneInformation          ; 0x00AC
	#SystemLookasideInformation         ; n * 0x0020
	#SystemSetTimeSlipEvent
  #SystemCreateSession				        ; set mode only
  #SystemDeleteSession				        ; set mode only
  #SystemInvalidInfoClass4			      ; invalid info class
  #SystemRangeStartInformation		    ; 0x0004 (fails If size != 4)
  #SystemVerifierInformation
  #SystemAddVerifier
  #SystemSessionProcessesInformation	; checked build only
  #MaxSystemInfoClass
EndEnumeration

Enumeration ;KWAIT_REASON
  #Executive
  #FreePage
  #PageIn
  #PoolAllocation
  #DelayExecution
  #Suspended
  #UserRequest
  #WrExecutive
  #WrFreePage
  #WrPageIn
  #WrPoolAllocation
  #WrDelayExecution
  #WrSuspended
  #WrUserRequest
  #WrEventPair
  #WrQueue
  #WrLpcReceive
  #WrLpcReply
  #WrVirtualMemory
  #WrPageOut
  #WrRendezvous
  #Spare2
  #Spare3
  #Spare4
  #Spare5
  #Spare6
  #WrKernel
  #MaximumWaitReason
EndEnumeration

;-MACROS
Macro NT_SUCCESS(Status)
  (Status >= 0)
EndMacro

Macro KWAIT_REASON
  l
EndMacro

Macro KPRIORITY
  l
EndMacro

;-STRUCTURES

CompilerIf Defined(UNICODE_STRING, #PB_Structure) = 0
  Structure UNICODE_STRING Align #PB_Structure_AlignC
    Length.w
    MaximumLength.w
    Buffer.i
  EndStructure
CompilerEndIf

CompilerIf Defined(CLIENT_ID, #PB_Structure) = 0
Structure CLIENT_ID Align #PB_Structure_AlignC
  UniqueProcess.i
  UniqueThread.i
EndStructure
CompilerEndIf

Structure VM_COUNTERS Align #PB_Structure_AlignC
  uPeakVirtualSize.l
  uVirtualSize.l
  uPageFaultCount.l
  uPeakWorkingSetSize.l
  uWorkingSetSize.l
  uQuotaPeakPagedPoolUsage.l
  uQuotaPagedPoolUsage.l
  uQuotaPeakNonPagedPoolUsage.l
  uQuotaNonPagedPoolUsage.l
  uPagefileUsage.l
  uPeakPagefileUsage.l
EndStructure

Structure IO_COUNTERS Align #PB_Structure_AlignC
  ReadOperationCount.LARGE_INTEGER
  WriteOperationCount.LARGE_INTEGER
  OtherOperationCount.LARGE_INTEGER
  ReadTransferCount.LARGE_INTEGER
  WriteTransferCount.LARGE_INTEGER
  OtherTransferCount.LARGE_INTEGER
EndStructure

Structure SYSTEM_THREAD Align #PB_Structure_AlignC
  ftKernelTime.FILETIME
  ftUserTime.FILETIME
  ftCreateTime.FILETIME
  dWaitTime.l
  pStartAddress.i
  Cid.CLIENT_ID          ;// process/thread ids
  dPriority.l
  dBasePriority.l
  dContextSwitches.l
  dThreadState.l
  WaitReason.KWAIT_REASON
  dReserved01.l
EndStructure

Structure SYSTEM_PROCESS_INFORMATION Align #PB_Structure_AlignC
  NextEntryDelta.l                 ;// relative offset
  NumberOfThreads.l
  Reserved.LARGE_INTEGER[3]
  CreateTime.LARGE_INTEGER
  UserTime.LARGE_INTEGER
  KernelTime.LARGE_INTEGER
  ImageName.UNICODE_STRING
  BasePriority.l
  ProcessId.l
  InheritedFromProcessId.l
  HandleCount.l
  Reserved2.l[2]
  PrivatePageCount.l
  VirtualMemoryCounters.VM_COUNTERS
  IoCounters.IO_COUNTERS
  Threads.SYSTEM_THREAD[0]
EndStructure

CompilerIf Defined(LIST_ENTRY, #PB_Structure) = 0
Structure LIST_ENTRY Align #PB_Structure_AlignC
  *Flink.LIST_ENTRY
  *Blink.LIST_ENTRY
EndStructure
CompilerEndIf

Structure EXCEPTION_REGISTRATION_RECORD Align #PB_Structure_AlignC
  Nextex.i
  Handler.i
EndStructure

CompilerIf Defined(NT_TIB, #PB_Structure) = 0
Structure NT_TIB Align #PB_Structure_AlignC
  *ExceptionList.EXCEPTION_REGISTRATION_RECORD
  StackBase.i
  StackLimit.i
  SubSystemTib.i
  StructureUnion
    FiberData.i
    Version.l
  EndStructureUnion
  ArbitraryUserPointer.i
  *Self.NT_TIB
EndStructure
CompilerEndIf

Structure PEB_LDR_DATA Align #PB_Structure_AlignC
  Length.l
  Initialized.b[4]
  SsHandle.i
  InLoadOrderModuleList.LIST_ENTRY ; // ref. to PLDR_DATA_TABLE_ENTRY->InLoadOrderModuleList
  InMemoryOrderModuleList.LIST_ENTRY ; // ref. to PLDR_DATA_TABLE_ENTRY->InMemoryOrderModuleList
  InInitializationOrderModuleList.LIST_ENTRY ; // ref. to PLDR_DATA_TABLE_ENTRY->InInitializationOrderModuleList
EndStructure

CompilerIf Defined(LDR_DATA_TABLE_ENTRY, #PB_Structure) = 0
Structure LDR_DATA_TABLE_ENTRY Align #PB_Structure_AlignC
  InLoadOrderModuleList.LIST_ENTRY;                 LIST_ENTRY
  InMemoryOrderModuleList.LIST_ENTRY;               LIST_ENTRY
  InInitializationOrderModuleList.LIST_ENTRY;       LIST_ENTRY
  BaseAddress.i;                                    PVOID
  EntryPoint.i;                                     PVOID
  SizeOfImage.l;                                    ULONG
  FullDllName.UNICODE_STRING;                       UNICODE_STRING
  BaseDllName.UNICODE_STRING;                       UNICODE_STRING
  Flags.l;                                          ULONG
  LoadCount.w;                                      SHORT
  TlsIndex.w;                                       SHORT
  HashTableEntry.LIST_ENTRY;                        LIST_ENTRY
  TimeDateStamp.l;                                  ULONG
EndStructure
CompilerEndIf

Structure LDR_DATA_TABLE_ENTRY_XP Align #PB_Structure_AlignC
  InLoadOrderModuleList.LIST_ENTRY
  InMemoryOrderModuleList.LIST_ENTRY
  InInitializationOrderModuleList.LIST_ENTRY
  DllBase.i
  EntryPoint.i
  SizeOfImage.l
  FullDllName.UNICODE_STRING
  BaseDllName.UNICODE_STRING
  Flags.l
  LoadCount.w
  TlsIndex.w
  
  StructureUnion
    HashLinks.LIST_ENTRY
    SectionPointer.i
    CheckSum.l
  EndStructureUnion
  
  StructureUnion
    TimeDateStamp.l
    ;// seems they are exist only on XP !!!
    LoadedImports.i
  EndStructureUnion
  
  *EntryPointActivationContext ; _ACTIVATION_CONTEXT * EntryPointActivationContext;
  PatchInformation.i
  ForwarderLinks.LIST_ENTRY
  ServiceTagLinks.LIST_ENTRY
  StaticLinks.LIST_ENTRY
EndStructure

Structure PEBLOCKROUTINE Align #PB_Structure_AlignC
  PebLock.i
EndStructure

Structure PEB_FREE_BLOCK Align #PB_Structure_AlignC
  *pfbNext.PEB_FREE_BLOCK
  Size.l
EndStructure

Structure RTL_DRIVE_LETTER_CURDIR Align #PB_Structure_AlignC
  Flags.w
  Length.w
  TimeStamp.l
  DosPath.UNICODE_STRING
EndStructure

Structure RTL_USER_PROCESS_PARAMETERS Align #PB_Structure_AlignC
  MaximumLength.l
  Length.l
  Flags.l
  DebugFlags.l
  ConsoleHandle.i
  ConsoleFlags.i
  StdInputHandle.i
  StdOutputHandle.i
  StdErrorHandle.i
  CurrentDirectoryPath.UNICODE_STRING
  CurrentDirectoryHandle.i
  DllPath.UNICODE_STRING
  ImagePathName.UNICODE_STRING
  CommandLine.UNICODE_STRING
  Environment.i
  StartingPositionLeft.l
  StartingPositionTop.l
  Width.l
  Height.l
  CharWidth.l
  CharHeight.l
  ConsoleTextAttributes.l
  WindowFlags.l
  ShowWindowFlags.l
  WindowTitle.UNICODE_STRING
  DesktopName.UNICODE_STRING
  ShellInfo.UNICODE_STRING
  RuntimeData.UNICODE_STRING
  DLCurrentDirectory.RTL_DRIVE_LETTER_CURDIR[$20]
EndStructure

Structure SECTION_IMAGE_INFORMATION Align #PB_Structure_AlignC
   EntryPoint.i
   StackZeroBits.l
   StackReserved.l
   StackCommit.l
   ImageSubsystem.l
   SubSystemVersionLow.w
   SubSystemVersionHigh.w
   Unknown1.l
   ImageCharacteristics.l
   ImageMachineType.l
   Unknown2.l[3]
EndStructure

Structure RTL_USER_PROCESS_INFORMATION Align #PB_Structure_AlignC
  Size.l
  ProcessHandle.i
  ThreadHandle.i
  ClientId.CLIENT_ID
  ImageInfo.SECTION_IMAGE_INFORMATION
EndStructure

Structure GDI_TEB_BATCH Align #PB_Structure_AlignC
  Offset.l
  HDC.l
  Buffer.l[310]
EndStructure

Structure RTL_ACTIVATION_CONTEXT_STACK_FRAME Align #PB_Structure_AlignC
  *Previous.RTL_ACTIVATION_CONTEXT_STACK_FRAME
  *ActivationContext
  Flags.l
EndStructure

Structure ACTIVATION_CONTEXT_STACK Align #PB_Structure_AlignC
  *ActiveFrame.RTL_ACTIVATION_CONTEXT_STACK_FRAME
  FrameListCache.LIST_ENTRY
  Flags.l
  NextCookieSequenceNumber.l
  StackId.l
EndStructure

Structure TEB_ACTIVE_FRAME_CONTEXT Align #PB_Structure_AlignC
  Flags.l
  *FrameName.Ascii
EndStructure

Structure TEB_ACTIVE_FRAME Align #PB_Structure_AlignC
  Flags.l
  *Previous.TEB_ACTIVE_FRAME
  *Context.TEB_ACTIVE_FRAME_CONTEXT
EndStructure

Structure PEB Align #PB_Structure_AlignC
  InheritedAddressSpace.b;                          BOOLEAN Reserved1[0]
  ReadImageFileExecOptions.b;                       BOOLEAN Reserved1[1]
  BeingDebugged.b;                                  BOOLEAN BeingDebugged
  Spare.b;                                          BOOLEAN Reserved2
  Mutant.i;                                         HANDLE  Reserved3[0]
  ImageBaseAddress.i;                               PVOID   Reserved3[1]
  *LoaderData.PEB_LDR_DATA;                         PPEB_LDR_DATA
  *ProcessParameters.RTL_USER_PROCESS_PARAMETERS;   RTL_USER_PROCESS_PARAMETERS
  SubSystemData.i;                                  PVOID
  ProcessHeap.i;                                    PVOID
  FastPebLock.i;                                    PVOID
  *FastPebLockRoutine.PEBLOCKROUTINE;               PPEBLOCKROUTINE
  *FastPebUnlockRoutine.PEBLOCKROUTINE;             PPEBLOCKROUTINE
  EnvironmentUpdateCount.l;                         ULONG
  KernelCallbackTable.i;                            PPVOID
  EventLogSection.i;                                PVOID
  EventLog.i;                                       PVOID
  *FreeList.PEB_FREE_BLOCK;                         PPEB_FREE_BLOCK
  TlsExpansionCounter.l;                            ULONG
  TlsBitmap.i;                                      PVOID
  TlsBitmapBits.l[$2];                              ULONG
  ReadOnlySharedMemoryBase.i;                       PVOID
  ReadOnlySharedMemoryHeap.i;                       PVOID
  ReadOnlyStaticServerData.i;                       PPVOID
  AnsiCodePageData.i;                               PVOID
  OemCodePageData.i;                                PVOID
  UnicodeCaseTableData.i;                           PVOID
  NumberOfProcessors.l;                             ULONG
  NtGlobalFlag.l;                                   ULONG
  Spare2.b[$4];                                     BYTE
  CriticalSectionTimeout.LARGE_INTEGER;             LARGE_INTEGER
  HeapSegmentReserve.l;                             ULONG
  HeapSegmentCommit.l;                              ULONG
  HeapDeCommitTotalFreeThreshold.l;                 ULONG
  HeapDeCommitFreeBlockThreshold.l;                 ULONG
  NumberOfHeaps.l;                                  ULONG
  MaximumNumberOfHeaps.l;                           ULONG
  ProcessHeaps.i;                                   PPVOID
  GdiSharedHandleTable.i;                           PVOID
  ProcessStarterHelper.i;                           PVOID
  GdiDCAttributeList.i;                             PVOID
  LoaderLock.i;                                     PVOID
  OSMajorVersion.l;                                 ULONG
  OSMinorVersion.l;                                 ULONG
  OSBuildNumber.l;                                  ULONG
  OSPlatformId.l;                                   ULONG
  ImageSubSystem.l;                                 ULONG
  ImageSubSystemMajorVersion.l;                     ULONG
  ImageSubSystemMinorVersion.l;                     ULONG
  GdiHandleBuffer.l[$22];                           ULONG
  PostProcessInitRoutine.l;                         ULONG
  TlsExpansionBitmap.l;                             ULONG
  TlsExpansionBitmapBits.b[$80];                    BYTE
  SessionId.l;                                      ULONG
EndStructure

Structure TEB Align #PB_Structure_AlignC
  Tib.NT_TIB;                                       NT_TIB
  EnvironmentPointer.i;                             PVOID
  Cid.CLIENT_ID;                                    CLIENT_ID
  ActiveRpcInfo.i;                                  PVOID
  ThreadLocalStoragePointer.i;                      PVOID
  *Peb.PEB;                                         PPEB
  LastErrorValue.l;                                 ULONG
  CountOfOwnedCriticalSections.l;                   ULONG
  CsrClientThread.i;                                PVOID
  Win32ThreadInfo.i;                                PVOID
  Win32ClientInfo.l[$1F];                           ULONG
  WOW32Reserved.i;                                  PVOID
  CurrentLocale.l;                                  ULONG
  FpSoftwareStatusRegister.l;                       ULONG
  SystemReserved1.i[$36];                           PVOID
  Spare1.i;                                         PVOID
  ExceptionCode.l;                                  ULONG
  SpareBytes1.l[$28];                               ULONG
  SystemReserved2.i[$A];                            PVOID
  GdiRgn.l;                                         ULONG
  GdiPen.l;                                         ULONG
  GdiBrush.l;                                       ULONG
  RealClientId.CLIENT_ID;                           CLIENT_ID
  GdiCachedProcessHandle.i;                         PVOID
  GdiClientPID.l;                                   ULONG
  GdiClientTID.l;                                   ULONG
  GdiThreadLocaleInfo.i;                            PVOID
  UserReserved.i[5];                                PVOID
  GlDispatchTable.i[$118];                          PVOID
  GlReserved1.l[$1A];                               ULONG
  GlReserved2.i;                                    PVOID
  GlSectionInfo.i;                                  PVOID
  GlSection.i;                                      PVOID
  GlTable.i;                                        PVOID
  GlCurrentRC.i;                                    PVOID
  GlContext.i;                                      PVOID
  LastStatusValue.l;                                NTSTATUS
  StaticUnicodeString.UNICODE_STRING;               UNICODE_STRING
  StaticUnicodeBuffer.w[$105];                      WCHAR
  DeallocationStack.i;                              PVOID
  TlsSlots.i[$40];                                  PVOID
  TlsLinks.LIST_ENTRY;                              LIST_ENTRY
  Vdm.i;                                            PVOID
  ReservedForNtRpc.i;                               PVOID
  DbgSsReserved.i[$2];                              PVOID
  HardErrorDisabled.l;                              ULONG
  Instrumentation.i[$10];                           PVOID
  WinSockData.i;                                    PVOID
  GdiBatchCount.l;                                  ULONG
  Spare2.l;                                         ULONG
  Spare3.l;                                         ULONG
  Spare4.l;                                         ULONG
  ReservedForOle.i;                                 PVOID
  WaitingOnLoaderLock.l;                            ULONG
  StackCommit.i;                                    PVOID
  StackCommitMax.i;                                 PVOID
  StackReserved.i;                                  PVOID
EndStructure


CompilerEndIf
; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 232
; FirstLine = 203
; Folding = -
; EnableAsm
; DisableDebugger
; CompileSourceDirectory