;
; ------------------------------------------------------------
;
;   PureBasic - Sprite SpecialFX example file
;
;    (c) 2002 - Fantaisie Software
;
; ------------------------------------------------------------
;

    If InitSprite() = 0
        MessageRequester("Error", "Can't open DirectX 7 Or later", 0)
        End
    EndIf

    If InitKeyboard() = 0 Or InitMouse() = 0
        MessageRequester("Error", "Can't open DirectX 7 or Mouse not found..", 0)
        End
    EndIf

    TranslucideStep = 1
    FilterX = -100

    ;
    ;-------- MessageReq and OpenScreen ---------
    ;

    MessageRequester("Information", "This is a little demo of PureBasic real-time 2D effects:"+Chr(10)+Chr(10)+"F1: Enable/Disable RGB Filters"+Chr(10)+"F2: Enable/Disable AlphaChannel"+Chr(10)+"F3: Enable/Disable Shadow"+Chr(10)+"F4: Start screen fading"+Chr(10)+"F5: Enable/Disable AlphaChannel color rotation"+Chr(10)+"+/-: Add/Remove PureBasic AlphaBlending sprite"+Chr(10)+Chr(10)+"Use the mouse :)... Enjoy !")

    If OpenScreen(800, 600, 32, "SpecialFX") = 0
       MessageRequester("Error", "Can't open a 800*600 - 32 bit screen !", 0)
       End
    EndIf

    ;
    ;-------- Load needed Stuff --------
    ;

    LoadSprite(0, "Data\Background.bmp"  )
    LoadSprite(1, "Data\PureBasic.bmp"   )
    LoadSprite(2, "Data\AlphaChannel.bmp", #PB_Sprite_Alpha)
  
    ;
    ;-------- Helper procedure --------
    ;
    Procedure$ GetOnOffText(Text$, State) 
      If State 
        Text$ + "On"
      Else
        Text$ + "Off"
      EndIf
    
      ProcedureReturn Text$
    EndProcedure
    
    ;
    ;-------- MainLoop --------
    ;

Repeat
    
    StartSpecialFX()
    
    For x=0 To 800 Step 256
        For y=0 To 600 Step 256
            DisplaySprite(0, x, y)
        Next
    Next
    
    ExamineMouse()
    
    ; --------------------------------- Translucide -----------------------------------------
    
    For k=0 To NbSprites
        DisplayTranslucentSprite(1, MouseX(), MouseY()+k*40, TranslucideValue)
        ;DisplayTransparentSprite(1, MouseX(), MouseY()+k*40)
    Next
    
    TranslucideValue+TranslucideStep
    
    If TranslucideValue > 255
        TranslucideStep = -1 : TranslucideValue = 255
    EndIf
    
    If TranslucideValue < 0
        TranslucideStep = 1 : TranslucideValue = 0
    EndIf
    
    ; --------------------------------- Alpha Channel ---------------------------------------
    
    If EnableAlpha
      ;
      DisplayAlphaSprite(2, 100, AlphaY)
      
      If EnableAlphaColor      
          ChangeAlphaIntensity(AlphaRed/4, 0, AlphaRed/2)
          AlphaRed+1
          If AlphaRed > 400 : AlphaRed = 0 : EndIf
      EndIf
    EndIf
    
    AlphaY+1
    If AlphaY > 600 : AlphaY = -100 : EndIf
        
    ; ------------------------------------ Shadow -------------------------------------------
    
    If EnableShadow
        DisplayShadowSprite(2, 50, 120)
        DisplayShadowSprite(2, 300, 320)
    EndIf
    
    ; ---------------------------------- RGB Filters ----------------------------------------
    
    If EnableRGBFilters
        DisplayRGBFilter(FilterX   , 100, 100, 100, 255, 120, 0)
        DisplayRGBFilter(FilterX+30, 300, 100, 100, 0, 120, 100)
        DisplayRGBFilter(FilterX+40, 350, 100, 100, 0, 0, 255)
    EndIf
    
    FilterX+1
    If FilterX > 800 : FilterX = -100 : EndIf
    
    ; ---------------------------------- Gamma Fading ----------------------------------------
    
    If EnableGamma
      Fade+FadeStep
      
      If Fade >= 255
        FadeStep = -1
      EndIf
      
      ChangeGamma(Fade, Fade, Fade)
      
      If Fade = 0
        FadeStep = 1
      EndIf
    EndIf
    
    StopSpecialFX()
    
    If StartDrawing(ScreenOutput())
      DrawingMode(1)
        
      DrawText(10, 10, GetOnOffText("F1: RGB Filters: ", EnableRGBFilters))
      DrawText(10, 30, GetOnOffText("F2: AphaChannel: ", EnableAlpha))
      DrawText(10, 50, GetOnOffText("F3: AphaCycle  : ", EnableAlphaColor))
      DrawText(10, 70, GetOnOffText("F4: SoftShadows: ", EnableShadow))
      DrawText(10, 90, GetOnOffText("F5: FadeIn/Out : ", EnableGamma))
    
      StopDrawing()
    EndIf
    
    ExamineKeyboard()
    
    If KeyboardReleased(#PB_Key_Add) : NbSprites+1 : EndIf
    If KeyboardReleased(#PB_Key_Subtract) And NbSprites>0 : NbSprites-1 : EndIf
  
    If KeyboardReleased(#PB_Key_F1) : EnableRGBFilters = 1-EnableRGBFilters : EndIf
    If KeyboardReleased(#PB_Key_F2) : EnableAlpha      = 1-EnableAlpha      : EndIf
    If KeyboardReleased(#PB_Key_F3) : EnableAlphaColor = 1-EnableAlphaColor : EndIf
    If KeyboardReleased(#PB_Key_F4) : EnableShadow     = 1-EnableShadow     : EndIf
    If KeyboardReleased(#PB_Key_F5) : EnableGamma      = 1-EnableGamma      : EndIf

    ;---- Inverse the buffers (the back become the front (visible)... And we can do the rendering on the back)
    
    FlipBuffers()
    
Until MouseButton(1) Or MouseButton(2) Or KeyboardPushed(#PB_Key_Escape)
  
End   