/* === Copyright Notice ===
 *
 *
 *                  PureBasic source code file
 *
 *
 * This file is part of the PureBasic Software package. It may not
 * be distributed or published in source code or binary form without
 * the expressed permission by Fantaisie Software.
 *
 * By contributing modifications or additions to this file, you grant
 * Fantaisie Software the rights to use, modify and distribute your
 * work in the PureBasic package.
 *
 *
 * Copyright (C) 2000-2010 Fantaisie Software - all rights reserved
 *
 */

#undef _WIN32_IE
#define _WIN32_IE  0x0500

#undef WINVER                // Allow use of features specific to Windows 95 and Windows NT 4 or later.
#define WINVER 0x0501        // Change this to the appropriate value to target Windows 98 and Windows 2000 or later.

#undef _WIN32_WINNT        // Allow use of features specific to Windows NT 4 or later.
#define _WIN32_WINNT 0x0501        // Change this to the appropriate value to target Windows 98 and Windows 2000 or later.

#undef _WIN32_WINDOWS        // Allow use of features specific to Windows 98 or later.
#define _WIN32_WINDOWS 0x0501 // Change this to the appropriate value to target Windows Me or later.


#define COBJMACROS
#define CINTERFACE

#ifdef VISUALC
	#pragma warning (disable: 4028)
#endif


#include <PureLibrary.h>
#include <Object/Object.h>
#include <Event/Event.h>
#include <CommCtrl.h>

#include <Gadget/GadgetCommon.h>

// Not declared in windows.h
#ifndef TVM_SETEXTENDEDSTYLE
  #define TVM_SETEXTENDEDSTYLE (TV_FIRST + 44)
#endif

#ifndef TVS_EX_DOUBLEBUFFER
  #define TVS_EX_DOUBLEBUFFER 0x0004
#endif



#define MSG_DirectoryChange 13120 // to check


#ifndef PB_EventNotProcessed
  #define PB_EventNotProcessed      (-0x2F2F2F2F)
#endif

// EventType
#define PB_EventType_Focus              14000
#define PB_EventType_LostFocus          14001
#define PB_EventType_ReturnKey          1281
#define PB_EventType_Change             768
#define PB_EventType_LeftClick          0
#define PB_EventType_RightClick         1
#define PB_EventType_LeftDoubleClick    2
#define PB_EventType_RightDoubleClick   3
#define PB_EventType_DragStart          14002


/* Gadget Coloring options:
 */
#define PB_Gadget_FrontColor      1
#define PB_Gadget_BackColor       2
#define PB_Gadget_LineColor       3
#define PB_Gadget_TitleFrontColor 4
#define PB_Gadget_TitleBackColor  5
#define PB_Gadget_GreyTextColor   6


struct PB_GadgetStructure;

typedef integer (M_PBVIRTUAL *GadgetCallbackProc)  (struct PB_GadgetStructure *Gadget, HWND Window, UINT Message, WPARAM wParam, LPARAM lParam);
typedef void    (M_PBVIRTUAL *FreeGadgetProc)         (struct PB_GadgetStructure *Gadget);
typedef integer (M_PBVIRTUAL *GetGadgetStateProc)     (struct PB_GadgetStructure *Gadget);
typedef void    (M_PBVIRTUAL *SetGadgetStateProc)     (struct PB_GadgetStructure *Gadget, integer State);
typedef void    (M_PBVIRTUAL *GetGadgetTextProc)      (struct PB_GadgetStructure *Gadget, int PreviousStringPosition);
typedef void    (M_PBVIRTUAL *SetGadgetTextProc)      (struct PB_GadgetStructure *Gadget, TCHAR *Text);
typedef integer (M_PBVIRTUAL *AddGadgetItem2Proc)  (struct PB_GadgetStructure *Gadget, int Position, TCHAR *Text, int *Image);
typedef integer (M_PBVIRTUAL *AddGadgetItem3Proc)  (struct PB_GadgetStructure *Gadget, int Position, TCHAR *Text, int *Image, int Flags);
typedef void    (M_PBVIRTUAL *RemoveGadgetItemProc)   (struct PB_GadgetStructure *Gadget, int Item);
typedef void    (M_PBVIRTUAL *ClearGadgetItemsProc)(struct PB_GadgetStructure *Gadget);
typedef void    (M_PBVIRTUAL *ResizeGadgetProc)       (struct PB_GadgetStructure *Gadget, int X, int Y, int Width, int Height);
typedef int     (M_PBVIRTUAL *CountGadgetItemsProc)   (struct PB_GadgetStructure *Gadget);
typedef int     (M_PBVIRTUAL *GetGadgetItemStateProc) (struct PB_GadgetStructure *Gadget, int Item);
typedef void    (M_PBVIRTUAL *SetGadgetItemStateProc) (struct PB_GadgetStructure *Gadget, int Item, int State);
typedef void    (M_PBVIRTUAL *GetGadgetItemTextProc)  (struct PB_GadgetStructure *Gadget, int Item, int Column, int PreviousStringPosition);
typedef void    (M_PBVIRTUAL *SetGadgetItemTextProc)  (struct PB_GadgetStructure *Gadget, int Item, TCHAR *Text, int Column);
typedef void    (M_PBVIRTUAL *OpenGadgetList2Proc)    (struct PB_GadgetStructure *Gadget, int Item);
typedef int     (M_PBVIRTUAL *GadgetXProc)            (struct PB_GadgetStructure *Gadget);
typedef int     (M_PBVIRTUAL *GadgetYProc)            (struct PB_GadgetStructure *Gadget);
typedef int     (M_PBVIRTUAL *GadgetWidthProc)        (struct PB_GadgetStructure *Gadget);
typedef int     (M_PBVIRTUAL *GadgetHeightProc)       (struct PB_GadgetStructure *Gadget);
typedef void    (M_PBVIRTUAL *HideGadgetProc)         (struct PB_GadgetStructure *Gadget, int State);
typedef void    (M_PBVIRTUAL *AddGadgetColumnProc)    (struct PB_GadgetStructure *Gadget, int Position, TCHAR *Text, int Width);
typedef void    (M_PBVIRTUAL *RemoveGadgetColumnProc) (struct PB_GadgetStructure *Gadget, int Position);
typedef integer (M_PBVIRTUAL *GetGadgetAttributeProc) (struct PB_GadgetStructure *Gadget, int Attribute);
typedef void    (M_PBVIRTUAL *SetGadgetAttributeProc) (struct PB_GadgetStructure *Gadget, int Attribute, integer Value);
typedef int     (M_PBVIRTUAL *GetGadgetItemAttribute2Proc) (struct PB_GadgetStructure *Gadget, int Item, int Attribute, int Column);
typedef void    (M_PBVIRTUAL *SetGadgetItemAttribute2Proc) (struct PB_GadgetStructure *Gadget, int Item, int Attribute, int Value, int Column);
typedef void    (M_PBVIRTUAL *SetGadgetColorProc)     (struct PB_GadgetStructure *Gadget, int ColorType, int Color);
typedef integer (M_PBVIRTUAL *GetGadgetColorProc)     (struct PB_GadgetStructure *Gadget, int ColorType);
typedef void    (M_PBVIRTUAL *SetGadgetItemColor2Proc)(struct PB_GadgetStructure *Gadget, int Item, int ColorType, int Color, int Column);
typedef int     (M_PBVIRTUAL *GetGadgetItemColor2Proc)(struct PB_GadgetStructure *Gadget, int Item, int ColorType, int Column);
typedef void    (M_PBVIRTUAL *SetGadgetItemDataProc)  (struct PB_GadgetStructure *Gadget, int Item, integer Value);
typedef integer (M_PBVIRTUAL *GetGadgetItemDataProc)  (struct PB_GadgetStructure *Gadget, int Item);
typedef void    (M_PBVIRTUAL *OptimalGadgetSizeProc)  (struct PB_GadgetStructure *Gadget, int *Width, int *Height);
typedef void    (M_PBVIRTUAL *SetActiveGadgetProc)    (struct PB_GadgetStructure *Gadget);
typedef HFONT   (M_PBVIRTUAL *GetGadgetFontProc)      (struct PB_GadgetStructure *Gadget);
typedef void    (M_PBVIRTUAL *SetGadgetFontProc)      (struct PB_GadgetStructure *Gadget, HFONT Font);
typedef void    (M_PBVIRTUAL *SetGadgetItemImageProc) (struct PB_GadgetStructure *Gadget, int Position, HBITMAP Image);



enum {  // gadget types
  PB_GadgetType_Unknown = 0,

  PB_GadgetType_Button,
  PB_GadgetType_String,
  PB_GadgetType_Text,
  PB_GadgetType_CheckBox,
  PB_GadgetType_Option,
  PB_GadgetType_ListView,
  PB_GadgetType_Frame3D,
  PB_GadgetType_ComboBox,
  PB_GadgetType_Image,
  PB_GadgetType_HyperLink,
  PB_GadgetType_Container,
  PB_GadgetType_ListIcon,
  PB_GadgetType_IPAddress,
  PB_GadgetType_ProgressBar,
  PB_GadgetType_ScrollBar,
  PB_GadgetType_ScrollArea,
  PB_GadgetType_TrackBar,
  PB_GadgetType_Web,
  PB_GadgetType_ButtonImage,
  PB_GadgetType_Calendar,
  PB_GadgetType_Date,
  PB_GadgetType_Editor,
  PB_GadgetType_ExplorerList,
  PB_GadgetType_ExplorerTree,
  PB_GadgetType_ExplorerCombo,
  PB_GadgetType_Spin,
  PB_GadgetType_Tree,
  PB_GadgetType_Panel,
  PB_GadgetType_Splitter,
  PB_GadgetType_MDI,
	PB_GadgetType_Scintilla,
	PB_GadgetType_Shortcut,
	PB_GadgetType_Canvas,

	PB_GadgetType_LastEnum // to easily know the size of the enumeration
};

typedef struct
{
  int                          GadgetType;    // Gadget Type for this VT
  int                          SizeOf;        // SizeOf the VT (for future compatibility

  GadgetCallbackProc           GadgetCallback;
  FreeGadgetProc               FreeGadget;
  GetGadgetStateProc           GetGadgetState;
  SetGadgetStateProc           SetGadgetState;
  GetGadgetTextProc            GetGadgetText;
  SetGadgetTextProc            SetGadgetText;
  AddGadgetItem2Proc           AddGadgetItem2;
  AddGadgetItem3Proc           AddGadgetItem3;
  RemoveGadgetItemProc         RemoveGadgetItem;
  ClearGadgetItemsProc         ClearGadgetItems;
  ResizeGadgetProc             ResizeGadget;
  CountGadgetItemsProc         CountGadgetItems;
  GetGadgetItemStateProc       GetGadgetItemState;
  SetGadgetItemStateProc       SetGadgetItemState;
  GetGadgetItemTextProc        GetGadgetItemText;
  SetGadgetItemTextProc        SetGadgetItemText;
  OpenGadgetList2Proc          OpenGadgetList2;
  GadgetXProc                  GadgetX;
  GadgetYProc                  GadgetY;
  GadgetWidthProc              GadgetWidth;
  GadgetHeightProc             GadgetHeight;
  HideGadgetProc               HideGadget;
  AddGadgetColumnProc          AddGadgetColumn;
  RemoveGadgetColumnProc       RemoveGadgetColumn;
  GetGadgetAttributeProc       GetGadgetAttribute;
  SetGadgetAttributeProc       SetGadgetAttribute;
  GetGadgetItemAttribute2Proc  GetGadgetItemAttribute2;
  SetGadgetItemAttribute2Proc  SetGadgetItemAttribute2;
  SetGadgetColorProc           SetGadgetColor;
  GetGadgetColorProc           GetGadgetColor;
  SetGadgetItemColor2Proc      SetGadgetItemColor2;
  GetGadgetItemColor2Proc      GetGadgetItemColor2;
  SetGadgetItemDataProc        SetGadgetItemData;
  GetGadgetItemDataProc        GetGadgetItemData;
  OptimalGadgetSizeProc        OptimalGadgetSize;
  SetActiveGadgetProc          SetActiveGadget;
  GetGadgetFontProc            GetGadgetFont;
  SetGadgetFontProc            SetGadgetFont;
  SetGadgetItemImageProc       SetGadgetItemImage;
} PB_GadgetVT;

typedef struct PB_GadgetStructure
{
  HWND         Gadget;
  PB_GadgetVT *VT;
  integer      UserData;      // for Get/SetGadgetData
  WNDPROC      OldCallback;   // for PB_Gadget_RegisterDestroy
  integer      Data[4];       // for gadget internal data. (mostly used for front/backcolor and such).
} PB_Gadget;

typedef struct
{
  HWND         CurrentWindow;
  int          FirstOptionGadget;

  HFONT        DefaultFont;

  HWND        *PanelStack;
  int          PanelStackIndex;
  int          PanelStackSize;

  HWND         ToolTipWindow;      // one tooltip window per thread

  // This is for CalendarGadget only. We need this as a global structure for the message processing,
  // but it must still be threadsave.
  //
  MONTHDAYSTATE TargetMonthArray[12];

  // This one if for the XP theme fix of the PanelGadget
  // Again, we need to return a global Brush value once per thread, so store it here
  HBRUSH       PanelBrush;

} PB_GadgetGlobals;

typedef struct
{
  HBITMAP Image;
  int     Index;
} PB_GadgetImageList_Entry;

typedef struct
{
  HIMAGELIST  SmallImageList;
  HIMAGELIST  LargeImageList;
  PB_GadgetImageList_Entry *ImageTable;
  int         ImageCount;
  int         TableSize;
} PB_GadgetImageList;


extern PB_Object *PB_Gadget_Objects;
extern integer    PB_Gadget_Globals;
extern HFONT      PB_Gadget_SystemFont;
extern int        PB_Gadget_CommonControlsVersion;
extern int        PB_Gadget_IsThemed;
extern HMODULE    PB_Gadget_UXThemeDLL;

#define PB_GetActiveGadget                 M_UnicodeFunction(PB_GetActiveGadget)
#define PB_UseGadgetList                   M_UnicodeFunction(PB_UseGadgetList)
#define PB_ShortcutGadget                  M_UnicodeFunction(PB_ShortcutGadget)

#define PB_Gadget_RegisterGadget           M_UnicodeFunction(PB_Gadget_RegisterGadget)
#define PB_Gadget_GetRootWindow            M_UnicodeFunction(PB_Gadget_GetRootWindow)
#define PB_Gadget_GetCommonControlsVersion M_UnicodeFunction(PB_Gadget_GetCommonControlsVersion)
#define PB_Gadget_FreeImageList						 M_UnicodeFunction(PB_Gadget_FreeImageList)
#define PB_Gadget_InitImageList						 M_UnicodeFunction(PB_Gadget_InitImageList)
#define PB_Gadget_AddImageList						 M_UnicodeFunction(PB_Gadget_AddImageList)
#define PB_Gadget_ClearImageList					 M_UnicodeFunction(PB_Gadget_ClearImageList)
#define PB_Gadget_FlushEvents							 M_UnicodeFunction(PB_Gadget_FlushEvents)
#define PB_Gadget_SendGadgetCommand        M_UnicodeFunction(PB_Gadget_SendGadgetCommand)
#define PB_Gadget_EnsureGadget        		 M_UnicodeFunction(PB_Gadget_EnsureGadget)

#define PB_Window_ProcessEvent     M_UnicodeFunction(PB_Window_ProcessEvent)
#define PB_Window_RawProcessEvent  M_UnicodeFunction(PB_Window_RawProcessEvent)


M_PBFUNCTION(LRESULT) PB_Window_RawProcessEvent(HWND Window, UINT Message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK PB_Window_ProcessEvent(HWND Window, UINT Message, WPARAM wParam, LPARAM lParam);

M_PBFUNCTION(void) PB_ResizeGadget(integer GadgetID, int x, int y, int Width, int Height);
M_PBFUNCTION(HWND) PB_Gadget_RegisterGadget(integer GadgetID, PB_Gadget *Gadget, HWND GadgetWindow, PB_GadgetVT *VT);
M_PBFUNCTION(integer)  PB_Gadget_GetCommonControlsVersion(void);
M_PBFUNCTION(void) PB_Gadget_PushGadgetList(HWND NewCurrentWindow);
M_PBFUNCTION(HWND) PB_Gadget_GetRootWindow(HWND Window);
M_PBFUNCTION(void) PB_Gadget_FlushEvents(void);
M_PBFUNCTION(void) PB_Gadget_GenericResizeGadget(PB_Gadget *Gadget, int x, int y, int Width, int Height);
M_PBFUNCTION(void) PB_Gadget_DrawListIconGrid(HWND Window, HDC DC, COLORREF Color);

M_PBFUNCTION(PB_GadgetImageList *) PB_Gadget_InitImageList(int NeedLargeList);
M_PBFUNCTION(void)                 PB_Gadget_FreeImageList(PB_GadgetImageList *ImageList);
M_PBFUNCTION(integer)              PB_Gadget_AddImageList(HBITMAP Image, PB_GadgetImageList *ImageList);
M_PBFUNCTION(void)                 PB_Gadget_ClearImageList(PB_GadgetImageList *ImageList);
M_PBFUNCTION(PB_Gadget *)          PB_IsGadget(integer GadgetID);
M_PBFUNCTION(void)                 PB_Gadget_SendGadgetCommand(HWND Window, int EventType);
M_PBFUNCTION(integer)							 PB_Gadget_EnsureGadget(HWND Gadget);
M_PBFUNCTION(void)                 PB_Gadget_AddInbetweenImage(HWND GadgetWindow, HIMAGELIST ImageList);

#define PB_Gadget_RedrawGadget(Window) RedrawWindow(Window, 0, 0, RDW_ERASE|RDW_INTERNALPAINT|RDW_INVALIDATE|RDW_FRAME)

M_PBFUNCTION(HBRUSH) PB_Gadget_CreateSharedBrush(int Color);
M_PBFUNCTION(void)   PB_Gadget_FreeSharedBrush(HBRUSH Brush);

// shared coloring functions for simple Gadgets
M_PBFUNCTION(void) PB_Gadget_SharedSetGadgetColor(PB_Gadget *Gadget, int ColorType, int Color);
M_PBFUNCTION(integer)  PB_Gadget_SharedGetGadgetColor(PB_Gadget *Gadget, int ColorType);
M_PBFUNCTION(void) PB_Gadget_SharedFreeGadget(PB_Gadget *Gadget);

M_PBFUNCTION(void) PB_FreeGadget(integer GadgetID);
M_PBFUNCTION(void) PB_SetGadgetAttribute(integer GadgetID, int Attribute, integer Value);
M_PBFUNCTION(void) PB_ClearGadgetItems(integer GadgetID);
M_PBFUNCTION(HWND) PB_UseGadgetList(HWND WindowID);
M_PBFUNCTION(integer) PB_GadgetType(integer GadgetID); // debugging
M_PBFUNCTION(integer) PB_GadgetX(integer GadgetID);
M_PBFUNCTION(integer) PB_GadgetY(integer GadgetID);
M_PBFUNCTION(integer) PB_GadgetWidth(integer GadgetID);
M_PBFUNCTION(integer) PB_GadgetHeight(integer GadgetID);
M_PBFUNCTION(integer) PB_GetGadgetState(integer GadgetID);
M_PBFUNCTION(integer) PB_CountGadgetItems(integer GadgetID);


#define PB_RectTopProperty    TEXT("PB_RectTop")
#define PB_RectBottomProperty TEXT("PB_RectBottom")



#define PB_Gadget_GetOrAllocateID(GadgetID) ((PB_Gadget *)PB_Object_GetOrAllocateID(PB_Gadget_Objects, GadgetID))
#define PB_Gadget_GetObject(GadgetID) 			((PB_Gadget *)PB_Object_GetObject			 (PB_Gadget_Objects, GadgetID))
#define PB_Gadget_FreeID(GadgetID) 											  PB_Object_FreeID         (PB_Gadget_Objects, GadgetID)
